﻿ARKINV_L = AceLibrary( "AceLocale-2.2" ):new( "ARKINV" )

ARKINV = AceLibrary( "AceAddon-2.0" ):new( "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1" )
local dd = AceLibrary( "Dewdrop-2.0" )
local gt = AceLibrary( "Gratuity-2.0" )
local PT = AceLibrary( "PeriodicTable-3.0" )


ARKINV_G = {

	PROGRAM_NAME = "ArkInventory",
	PROGRAM_VERSION = 1.41,
	PROGRAM_BETA = nil, -- "2007-02-10-01-45",
	DEBUG = false,
	
	COROUTINE = {
		["RESTACK"] = nil,
	},

	ME = UnitName( "player" ) .. " - " .. GetRealmName(),
	
	player_skills = { },
	
	MODE = {
		["EDIT"] = false,
		["BANK"] = false,
		["COMBAT"] = false,
		["UPDATE"] = {
			["BAG"] = false,
			["BANK"] = false,
		},
	},
	
	LOCATION_BAG = 1, -- hardcoded, do not change
	LOCATION_BANK = 2, -- hardcoded, do not change
	LOCATION_KEY = 3, -- hardcoded, do not change
	LOCATION = { },
	
	WINDOW_OFFSET = 9, -- hardcoded padding size for gap inside container
	WINDOW_MIN_ROW = 1,
	WINDOW_MIN_COL = 6,

	WINDOW_MIN_WIDTH = 200,
	WINDOW_MIN_HEIGHT = 40,

	FADE_ALPHA = 0.6,
	BAG_SLOT_SIZE,
	
	-- slot type numbers, do not change this order, just add new ones to the end of the list
	SLOT_UNKNOWN = 0,
	SLOT_BAG = 1,
	SLOT_KEY = 3,
	SLOT_PROJECTILE = 4,
	SLOT_SOULSHARD = 5,
	SLOT_HERB = 6,
	SLOT_ENCHANTING = 7,
	SLOT_ENGINEERING = 8,
	SLOT_GEM = 9,
	SLOT_MINING = 10,
	SLOT_PROJECTILE_BULLET = 11,
	SLOT_PROJECTILE_ARROW = 12,

	GUI_NAME = "ARKINV_MainFrame",

	BAR_DEFAULT_COLOUR = { r = 0.0, g = 0.0, b = 0.4, a = 0.4 },
	
	SLOT_SORT_NAME = 1,
	SLOT_SORT_BAGSLOT = 2,
	
	CATEGORY = { }, -- see CategoryGenerate() for how this gets populated
	
	CATEGORY_ID_DEFAULT = 50,
	
	CATEGORY_SYSTEM = { -- do NOT change the indicies - if you have to then see the ConvertOldOptions() function to remap it
		[1] = ARKINV_L["CATEGORY_TRASH"],
		[11] = ARKINV_L["CATEGORY_SOULBOUND"],
		[12] = ARKINV_L["CATEGORY_CONSUMABLE"],
		[13] = ARKINV_L["CATEGORY_CONTAINER"],
		[14] = ARKINV_L["CATEGORY_KEY"],
		[15] = ARKINV_L["CATEGORY_MISCELLANEOUS"],
		[16] = ARKINV_L["CATEGORY_REAGENT"],
		[17] = ARKINV_L["CATEGORY_RECIPE"],
		[18] = ARKINV_L["CATEGORY_PROJECTILE"],
		[19] = ARKINV_L["CATEGORY_QUEST"],
		[20] = ARKINV_L["CATEGORY_TRADEGOODS"],
		[22] = ARKINV_L["CATEGORY_SOULSHARD"],
		[23] = ARKINV_L["CATEGORY_EQUIPMENT"],
		[24] = ARKINV_L["CATEGORY_MOUNT"],
		[25] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"],
		[26] = ARKINV_L["CATEGORY_FOOD"],
		[27] = ARKINV_L["CATEGORY_DRINK"],
		[28] = ARKINV_L["CATEGORY_POTION_MANA"],
		[29] = ARKINV_L["CATEGORY_POTION_HEAL"],
		[32] = ARKINV_L["CATEGORY_PROJECTILE_BULLET"],
		[33] = ARKINV_L["CATEGORY_PROJECTILE_ARROW"],
		[34] = ARKINV_L["CATEGORY_PET_NONCOMBAT"],
		[35] = ARKINV_L["CATEGORY_CORE_MATS"],
		-- [36] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT_WEAPON"],
		-- [37] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT_ARMOUR"],
		-- [38] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT_TRINKET"],
		[39] = ARKINV_L["CATEGORY_POTION"],
		[40] = ARKINV_L["CATEGORY_FOOD_PET"],
		[50] = ARKINV_L["CATEGORY_DEFAULT"],
		[51] = ARKINV_L["CATEGORY_TRADEGOODS_DEVICES"],
		[51] = ARKINV_L["CATEGORY_TRADEGOODS_EXPLOSIVES"],
		[53] = ARKINV_L["CATEGORY_TRADEGOODS_PARTS"],
		[54] = ARKINV_L["CATEGORY_REPUTATION"],
		
		-- Reputation.Turnin
	},

	CATEGORY_PROFESSION = { -- do NOT change the indicies
		[101] = ARKINV_L["CATEGORY_PROFESSION_HERBALISM"],
		[102] = ARKINV_L["CATEGORY_PROFESSION_FISHING"],
		[103] = ARKINV_L["CATEGORY_PROFESSION_MINING"],
		[104] = ARKINV_L["CATEGORY_PROFESSION_SKINNING"],
		[105] = ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"],
		[106] = ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"],
		[107] = ARKINV_L["CATEGORY_PROFESSION_COOKING"],
		[108] = ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"],
		[109] = ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"],
		[110] = ARKINV_L["CATEGORY_PROFESSION_TAILORING"],
		[111] = ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"],
		[112] = ARKINV_L["CATEGORY_PROFESSION_FIRSTAID"],
		[113] = ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"],
	},
	
	CATEGORY_CLASS = { -- do NOT change the indicies
		[201] = ARKINV_L["CATEGORY_CLASS_DRUID"],
		[202] = ARKINV_L["CATEGORY_CLASS_HUNTER"],
		[203] = ARKINV_L["CATEGORY_CLASS_MAGE"],
		[204] = ARKINV_L["CATEGORY_CLASS_PALADIN"],
		[205] = ARKINV_L["CATEGORY_CLASS_PRIEST"],
		[206] = ARKINV_L["CATEGORY_CLASS_ROGUE"],
		[207] = ARKINV_L["CATEGORY_CLASS_SHAMAN"],
		[208] = ARKINV_L["CATEGORY_CLASS_WARLOCK"],
		[209] = ARKINV_L["CATEGORY_CLASS_WARRIOR"],
	},

	CATEGORY_EMPTY = { -- do NOT change the indicies
		[301] = ARKINV_L["CATEGORY_EMPTY"],
		[2] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		[3] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		[4] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE"],
		[5] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		[6] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		[7] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		[8] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		[9] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		[10] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		[30] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		[31] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		[302] = ARKINV_L["CATEGORY_EMPTY_UNKNOWN"],
	},

	CACHE_CATEGORY_DEFAULT = { },
	
}

ARKINV_G.LOCATION = {

	[ARKINV_G.LOCATION_BAG] = {
		["NAME"] = ARKINV_L["LOCATION_BAG"],
		["TEXTURE"] = "Interface\\Icons\\INV_Misc_Bag_16",
		["IDS"] = { 0, 1, 2, 3, 4 },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },
		
		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},

	[ARKINV_G.LOCATION_BANK] = {
		["NAME"] = ARKINV_L["LOCATION_BANK"],
		["TEXTURE"] = "Interface\\Icons\\INV_Box_03",
		["IDS"] = { -1, 5, 6, 7, 8, 9, 10, 11 },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },

		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},

	[ARKINV_G.LOCATION_KEY] = {
		["NAME"] = ARKINV_L["LOCATION_KEY"],
		["TEXTURE"] = "Interface\\Icons\\INV_Misc_Key_04",
		["IDS"] = { -2 },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },

		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},
}


ARKINV_SLOT_TABLE_DEFAULT_COLOUR = { r = 0.3, g = 0.3, b = 0.3 }

ARKINV_SLOT_TABLE = {
	[ARKINV_G.SLOT_UNKNOWN] = {
		["name"] = ARKINV_L["NAME_CONTAINER_UNKNOWN"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_UNKNOWN"],
		["colour"] = { r = 1.0, g = 0.0, b = 0.0 }, -- red
	},
	[ARKINV_G.SLOT_BAG] = {
		["name"] = ARKINV_L["NAME_CONTAINER_BAG"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_KEY] = {
		["name"] = ARKINV_L["NAME_CONTAINER_KEY"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		["colour"] = { r = 1.0, g = 1.0, b = 0.0 }, -- yellow,
	},
	[ARKINV_G.SLOT_SOULSHARD] = {
		["name"] = ARKINV_L["NAME_CONTAINER_SOULSHARD"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		["colour"] = { r = 1.0, g = 0.0, b = 1.0 }, -- magenta
		["pt"] = "Container.ItemsInType.Soul Shard",
	},
	[ARKINV_G.SLOT_HERB] = {
		["name"] = ARKINV_L["NAME_CONTAINER_HERB"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		["colour"] = { r = 0.0, g = 1.0, b = 0.0 }, -- green
		["pt"] = "Container.ItemsInType.Herb",
	},
	[ARKINV_G.SLOT_ENCHANTING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_ENCHANTING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		["colour"] = { r = 0.0, g = 0.0, b = 1.0 }, -- blue
		["pt"] = "Container.ItemsInType.Enchanting",
	},
	[ARKINV_G.SLOT_ENGINEERING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_ENGINEERING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Engineering",
	},
	[ARKINV_G.SLOT_GEM] = {
		["name"] = ARKINV_L["NAME_CONTAINER_GEM"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Gem",
	},
	[ARKINV_G.SLOT_MINING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_MINING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Mining",
	},
	[ARKINV_G.SLOT_PROJECTILE] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
	},
	[ARKINV_G.SLOT_PROJECTILE_BULLET] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE_BULLET"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Bullet",
	},
	[ARKINV_G.SLOT_PROJECTILE_ARROW] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE_ARROW"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Arrow",
	}
}


-- Binding Variables
BINDING_HEADER_ARKINV = ARKINV_G.PROGRAM_NAME
BINDING_NAME_ARKINV_TOGGLE_BAG = ARKINV_L["BINDING_TOGGLE_BAG"]
BINDING_NAME_ARKINV_TOGGLE_KEY = ARKINV_L["BINDING_TOGGLE_KEY"]
BINDING_NAME_ARKINV_TOGGLE_BANK = ARKINV_L["BINDING_TOGGLE_BANK"]
BINDING_NAME_ARKINV_TOGGLE_EDIT = ARKINV_L["BINDING_TOGGLE_EDIT"]
BINDING_NAME_ARKINV_RESTACK_BAG = ARKINV_L["BINDING_RESTACK_BAG"]


ARKINV:RegisterDB( "ARKINVDB" )

ARKINV:RegisterDefaults( "profile", {
	["option"] = {
		["version"] = 0,
		["global"] = {
			["useglobal"] = true, -- true means use the bag settings for all locations, otherwise use each locations settings
			["remember"] = {
				["bank"] = true, -- keep bank data when leaving the bank
				["alt"] = true, -- keep bag & keyring on logout
			},
			["auto"] = {
				["open"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
				},
				["close"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
					["combat"] = true,
				},
			},
			["framehide"] = {
				["blizzard"] = true,
				["status"] = false,
				["header"] = false,
				["changer"] = false,
			},
			["category"] = {
				["custom"] = { },
				["next"] = -10,  -- id for next custom category
				["item"] = { },
				["pt"] = { },
			},
		},
		["local"] = {
			["*"] = {
				["window"] = {
					["scale"] = 1,
					["width"] = 12,
					["border"] = true,
					["colour"] = {
						["background"] = {
							["r"] = 0,
							["g"] = 0,
							["b"] = 0,
							["a"] = 0.75,
						},
						["border"] = {
							["r"] = 1,
							["g"] = 1,
							["b"] = 1,
						},
					},
					["pad"] = 8,
					["anchor"] = 3,   -- 1=BOTTOMRIGHT, 2=BOTTOMLEFT, 3=TOPLEFT, 4=TOPRIGHT
				},
				["bar"] = {
					["per"] = 3,
					["pad"] = {
						["internal"] = 8,
						["external"] = 8,
					},
					["border"] = false,
					["colour"] = {
						["background"] = ARKINV_G.BAR_DEFAULT_COLOUR,
						["border"] = ARKINV_G.BAR_DEFAULT_COLOUR,
					},
					["showempty"] = false,
					["anchor"] = 1,  -- 1=BOTTOMRIGHT, 2=BOTTOMLEFT, 3=TOPLEFT, 4=TOPRIGHT
					["direction"] = 1,  -- 1=HORIZONTAL, 2=VERTICAL
					["compact"] = false,
				},
				["slot"] = {
					["empty"] = {
						["alpha"] = 0.1,
						["icon"] = true,
						["clump"] = false,
					},
					["data"] = ARKINV_SLOT_TABLE,
					["pad"] = 2,
					["border"] = true,
					["fade"] = true,
					["ignorehidden"] = false,
				},
				["sort"] = {
					["type"] = ARKINV_G.SLOT_SORT_BAGSLOT,
					["quality"] = true,
					["category"] = false,
					["location"] = true,
					["instant"] = false,
					["reversed"] = false,
				},
				["category"] = { -- which bar a category lives on, category = bar
					[ARKINV_G.CATEGORY_ID_DEFAULT] = 1,
				},
			},
		},
	},

} )

ARKINV:RegisterDefaults( "account", {
	["cache"] = {
		["who"] = {
			["*"] = {
				["loc"] = {
					["*"] = {
						["bag"] = { },
						["bar"] = { },
						["container"] = { },
						["slot_count"] = 0,
						["bar_count"] = 0,
					},
				},
				["name"] = "",
				["class"] = "",
				["faction"] = nil,
				["skills"] = { },
			},
		},
	},
	
} )



local ARKINV_SlashCommandOptions = {
	type = "group",
	args = {

		gui = {
			type = "group",
			name = "gui",
			desc = "gui options",
			args = {
				reset = {
					type = "execute",
					name = "reset",
					desc = "centers the interface on the screen",
					func = function()
						for loc_id in pairs( ARKINV_G.LOCATION ) do
							getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetPoint( "TOPLEFT", UiParent, "CENTER" )
						end
					end
				},
			},
		},
		
		db = {
			type = "group",
			name = "db",
			desc = "db options",
			args = {
				reset = {
					type = "group",
					name = "reset",
					desc = "resets all options back to the defaults",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the database reset",
							func = function() ARKINV:DatabaseReset() end
						},
					},
				},
			},
		},
		
		cache = {
			type = "group",
			name = "cache",
			desc = "cache options",
			args = {
				erase = {
					type = "group",
					name = "erase",
					desc = "erases all cached data",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the cache erase",
							func = function() ARKINV:CacheErase() end
						},
					},
				},
			},
		},
		
	},
}

ARKINV:RegisterChatCommand( { "/arkinv", "/ai" }, ARKINV_SlashCommandOptions )


function ARKINV:DatabaseReset()

	-- /ai db reset confirm

	self:ContainerCloseAll()

	self:ResetDB( "profile" )
	self:Print( GREEN_FONT_COLOR_CODE .. "Database has been reset." )
	self:Print( GREEN_FONT_COLOR_CODE .. "All options are back at defaults." )
	
	self:CategoryGenerate()
	
	self:BagScanRequiredAll()
	self:ContainerGenerateRebuildAll()

end

function ARKINV:CacheErase()

	-- /ai cache erase confirm

	self:ContainerCloseAll()

	self:ResetDB( "account" )
	self:Print( "All cached data has been erased." )
	
	self:CategoryGenerate()
	
	self:BagScanRequiredAll()
	self:ContainerGenerateRebuildAll()
	
end



function ARKINV:Debug( msg )
	if ARKINV_G.DEBUG then
		if DEFAULT_CHAT_FRAME then
			if type( msg ) == "table" then
				for k, v in pairs( msg ) do
					if not v then
						msg[k] = "nil"
					end
				end
				ARKINV:Print( table.concat( msg ) )
			else
				ARKINV:Print( msg )
			end
		end
	end
end


function ARKINV:tableSum( tbl, fcn ) --fcn(v)
	local r = 0
	for k, v in pairs( tbl ) do
		r = r + ( fcn( v ) or 0 )
	end
	return r
end

function ARKINV:tableMax( tbl, fcn )
	local r = nil
	for k, v in pairs( tbl ) do
		if not r then
			r = ( fcn( v ) or 0 )
		else
			if ( fcn( v ) or 0 ) > r then
				r = ( fcn( v ) or 0 )
			end
		end
	end
	return r
end

function ARKINV:tableElements( tbl )
	local r = 0
	for _, _ in pairs( tbl ) do
		r = r + 1
	end
	return r
end

function ARKINV:spairs( tbl, comparator )

	local sortedKeys = {}
	for k, v in pairs( tbl ) do
		tinsert( sortedKeys, k )
	end
	sort( sortedKeys, comparator )
	local i = 0
	local function _f( _s, _v )
		i = i + 1
		local k = sortedKeys[i]
		if ( k ) then
			return k, tbl[k]
		end
	end
	return _f, nil, nil
end

function ARKINV:strsplit( delimiter, text )
  local list = {}
  local pos = 1
  if strfind( "", delimiter, 1 ) then -- this would result in endless loops
    return nil
  end
  while 1 do
    local first, last = strfind( text, delimiter, pos )
    if first then -- found?
      tinsert( list, strsub( text, pos, first - 1 ) )
      pos = last + 1
    else
      tinsert( list, strsub( text, pos ) )
      break
    end
  end
  return list
end

function ARKINV:PT_ItemInSets( item, setnames )

	for setname in string.gmatch( setnames, "[^,]+" ) do
		
		r = PT:ItemInSet( item, setname )
		if r then
			return r
		end
		
	end

end





function ARKINV:OnInitialize()
	-- Called when the addon is loaded

	self:ConvertOldOptions()

end

function ARKINV:OnEnable()
	-- Called when the addon is enabled


	self:CategoryGenerate()

	self:RegisterEvent( "BAG_UPDATE" )
	self:RegisterEvent( "PLAYERBANKSLOTS_CHANGED" ) -- one of the slots in bag -1 (main bank) have changed
	-- self:RegisterBucketEvent( { "BAG_UPDATE", "PLAYERBANKSLOTS_CHANGED" }, 0.1, "BUCKET_BAG_UPDATE" )

	self:RegisterEvent( "ITEM_LOCK_CHANGED" )
	
	self:RegisterEvent( "BAG_UPDATE_COOLDOWN" )
	
	--self:RegisterEvent( "PLAYERBANKBAGSLOTS_CHANGED" ) -- one of the bank bagslots has changed (doesn't appear to trigger)
	
	--self:RegisterEvent( "UPDATE_INVENTORY_ALERTS" )
	self:RegisterEvent( "UNIT_INVENTORY_CHANGED" )
	
	
	self:RegisterEvent( "PLAYER_REGEN_DISABLED" ) -- player about to enter combat
	self:RegisterEvent( "PLAYER_REGEN_ENABLED" ) -- player left combat

	self:RegisterEvent( "BANKFRAME_OPENED" )
	self:RegisterEvent( "BANKFRAME_CLOSED" )
	
	self:RegisterEvent( "MAIL_SHOW" )
	self:RegisterEvent( "MAIL_CLOSED" )

	self:RegisterEvent( "TRADE_SHOW" )
	self:RegisterEvent( "TRADE_CLOSED" )

	self:RegisterEvent( "AUCTION_HOUSE_SHOW" )
	self:RegisterEvent( "AUCTION_HOUSE_CLOSED" )

	self:RegisterEvent( "MERCHANT_SHOW" )
	self:RegisterEvent( "MERCHANT_CLOSED" )
	
	
	
	self:RegisterEvent( "PLAYER_LOGIN" ) --Triggered immediately before PLAYER_ENTERING_WORLD on login and UI Reload, but NOT when entering/leaving instances.
	self:RegisterEvent( "PLAYER_LOGOUT" ) --Sent when the player logs out or the UI is reloaded, after PLAYER_LEAVING_WORLD, but before variables are saved.
	--self:RegisterEvent( "PLAYER_QUIT" )
	

	-- tag all bags as needed to be scanned
	self:BagScanRequiredAll()
	
	self:Print( "v" .. ARKINV_G.PROGRAM_VERSION .. " Enabled.  Type /ARKINV or /AI for help." )

	
	self:SkillGet()
	--self:SkillPrint()
	
	_, self.db.account.cache.who[ARKINV_G.ME].class = UnitClass( "player" ) -- localised, internal
	_, self.db.account.cache.who[ARKINV_G.ME].faction = UnitFactionGroup( "player" )  -- internal, localised
	self.db.account.cache.who[ARKINV_G.ME].name = ARKINV_G.ME .. " - " .. self.db.account.cache.who[ARKINV_G.ME].faction

	self:HookBlizzardAPI()
	
end

function ARKINV:OnDisable()
	-- Called when the addon is disabled

	--self:UnhookAll()
	
	self:ContainerCloseAll()
	
	self:Debug( "Disabled" )
	
end



function ARKINV:BUCKET_BAG_UPDATE( bagnum_table )

	self:Debug( { RED_FONT_COLOR_CODE, "BUCKET_BAG_UPDATE()" } )

	ARKINV:ContainerRestackResume()

	self:BagScanRequiredAll()
	self:ContainerGenerateAll()
	
end

function ARKINV:BAG_UPDATE( bagnum )

	self:Debug( { RED_FONT_COLOR_CODE, "BAG_UPDATE( ", bagnum, " )" } )
	-- a bag just had it's contents changed, usually triggers in pairs

	ARKINV:ContainerRestackResume()

	if not bagnum or ARKINV_G.MODE.BANK then
		-- at the bank, scan everything - stupid corner cases require this
		self:BagScanRequiredAll()
		self:ContainerGenerateAll()
	else
		self:BagScanRequired( { bagnum } )
		self:ContainerGenerateAll( self:BagLocation( bagnum ) )
	end
	
end

function ARKINV:BAG_UPDATE_COOLDOWN( arg1 )
	
	-- no cooldown data is saved so a scan is not required, just draw the window
	self:Debug( { RED_FONT_COLOR_CODE, "BAG_UPDATE_COOLDOWN( ", arg1, " )" } )
	
	-- if we're in combat ignore cooldown updates
	if not ARKINV_G.MODE.COMBAT then

		if not arg1 then
			self:ContainerGenerateAll()
		else
			self:GenerateContainer( self:BagLocation( arg1 ) )
		end
		
	end
	
end

function ARKINV:ITEM_LOCK_CHANGED()
	-- no lock data is saved so a scan is not required, just draw the window

	self:Debug( { RED_FONT_COLOR_CODE, "ITEM_LOCK_CHANGED()" } )
	
	-- if we're in combat ignore item locks
	if not ARKINV_G.MODE.COMBAT then
		self:ContainerGenerateAll()
	end

end

function ARKINV:UPDATE_INVENTORY_ALERTS()

	self:Debug( { RED_FONT_COLOR_CODE, "UPDATE_INVENTORY_ALERTS()" } )

end

function ARKINV:UNIT_INVENTORY_CHANGED( arg1 )

	self:Debug( { RED_FONT_COLOR_CODE, "UNIT_INVENTORY_CHANGED( ", arg1, " )" } )

end

function ARKINV:PLAYER_REGEN_DISABLED()
	-- entered combat
	
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_DISABLED()" } )
	
	ARKINV_G.MODE.COMBAT = true
	
	if self.db.profile.option.global.auto.close.combat then
		self:ContainerCloseAll()
	end
	
end

function ARKINV:PLAYER_REGEN_ENABLED()
	-- left combat
	
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_ENABLED()" } )
	
	ARKINV_G.MODE.COMBAT = false
	self:ContainerGenerateAll()
	
end

function ARKINV:BANKFRAME_OPENED()

	self:Debug( { RED_FONT_COLOR_CODE, "BANKFRAME_OPENED()" } )
	
	ARKINV_G.MODE.BANK = true
	
	self:BagScanRequiredAll()

	if self.db.profile.option.global.framehide.blizzard then
	
		if self.db.profile.option.global.auto.open.bank then
			self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
			self:ContainerOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME )
		else
			-- regenerate the view in case they were looking at the bank "offline", make it "online"
			self:ContainerOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME )
		end

		self:ContainerGenerateRefresh( ARKINV_G.LOCATION_BANK )
	
	end
	
end

function ARKINV:BANKFRAME_CLOSED()

	self:Debug( { RED_FONT_COLOR_CODE, "BANKFRAME_CLOSED()" } )
	
	ARKINV_G.MODE.BANK = false

	if self.db.profile.option.global.auto.close.bank then
		-- close windows on leaving the bank
		self:ContainerCloseAll()
	else
		-- refresh the bank window so it shows offline
		self:ContainerGenerateRefresh( ARKINV_G.LOCATION_BANK )
	end
	
end


function ARKINV:PLAYERBANKBAGSLOTS_CHANGED()
	-- doesnt seem to be triggering
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYERBANKBAGSLOTS_CHANGED" } )
	self:BagChangerUpdateBagSlotStatus()
	self:BagScanRequiredAll()
	self:ContainerGenerateRedrawAll()
end


function ARKINV:PLAYERBANKSLOTS_CHANGED()
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYERBANKSLOTS_CHANGED" } )
	ARKINV:BAG_UPDATE()
end


function ARKINV:MAIL_SHOW()
	self:Debug( { RED_FONT_COLOR_CODE, "MAIL_SHOW" } )
	if self.db.profile.option.global.auto.open.mail and self.db.profile.option.global.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:MAIL_CLOSED()
	self:Debug( { RED_FONT_COLOR_CODE, "MAIL_CLOSED" } )
	if self.db.profile.option.global.auto.close.mail then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:TRADE_SHOW()
	self:Debug( { RED_FONT_COLOR_CODE, "TRADE_SHOW" } )
	if self.db.profile.option.global.auto.open.trade and self.db.profile.option.global.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:TRADE_CLOSED()
	self:Debug( { RED_FONT_COLOR_CODE, "TRADE_CLOSED" } )
	if self.db.profile.option.global.auto.close.trade then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:AUCTION_HOUSE_SHOW()
	self:Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_SHOW" } )
	if self.db.profile.option.global.auto.open.auction and self.db.profile.option.global.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:AUCTION_HOUSE_CLOSED()
	self:Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_CLOSED" } )
	if self.db.profile.option.global.auto.close.auction then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:MERCHANT_SHOW()
	self:Debug( { RED_FONT_COLOR_CODE, "MERCHANT_SHOW" } )
	if self.db.profile.option.global.auto.open.merchant and self.db.profile.option.global.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:MERCHANT_CLOSED()
	self:Debug( { RED_FONT_COLOR_CODE, "MERCHANT_CLOSED" } )
	if self.db.profile.option.global.auto.close.merchant then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:PLAYER_LOGIN()
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGIN" } )
	self:CacheCleanup()
end

function ARKINV:PLAYER_LOGOUT()
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGOUT" } )
	-- scan everything on logout
	--self:BagScanRequiredAll()
	--self:BagScanAll()
	self:CacheCleanup()
end

function ARKINV:PLAYER_QUIT()
	self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGOUT" } )
	self:CacheCleanup()
end






function ARKINV:ContainerOpen( loc_id, player )

	if not loc_id then
		return
	end
	
	if not player then
		player = ARKINV_G.ME
	end

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):Show()

	ARKINV_G.LOCATION[loc_id].redraw = true
		
	if ARKINV_G.LOCATION[loc_id].player ~= player then
		ARKINV_G.LOCATION[loc_id].player = player
		self:ContainerGenerateRebuild( loc_id )
	else
		self:ContainerGenerateRefresh( loc_id )
	end

end

function ARKINV:ContainerCloseAll()
	self:ContainerClose()
end

function ARKINV:ContainerClose( w )

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		if not w or w == loc_id then
			getglobal( ARKINV_G.GUI_NAME .. loc_id ):Hide()
		end
	end
	
	if self.db.profile.option.global.framehide.blizzard and ARKINV_G.MODE.BANK and w and w == ARKINV_G.LOCATION_BANK then
		-- close blizzards bank frame if we're hiding blizzard frames, we're at the bank, and the bank window was closed
		CloseBankFrame()
	end
	
	if ARKINV_G.MODE.EDIT then
		-- if the edit mode is active then disable edit mode and taint so it's rebuilt when next opened
		ARKINV_G.MODE.EDIT = false
		self:ContainerGenerateRebuildAll()
	end
	
end

function ARKINV:ContainerToggle( loc_id )

	local obj = getglobal( ARKINV_G.GUI_NAME .. loc_id )

	if obj then
		if obj:IsVisible() then
			self:ContainerClose( loc_id )
		else
			self:ContainerOpen( loc_id )
		end
	end
	
end



function ARKINV:BagLocation( id )

	if not id then
		self:Print( RED_FONT_COLOR_CODE .. "BagLocation(), nil passed" )
		return
	end
	
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			if bagnum == id then
				return loc_id
			end
		end
	end

	self:Print( RED_FONT_COLOR_CODE .. "BagLocation( " .. id .. " ), value not coded" )
	return nil

end

function ARKINV:BagType( id )

	if id == -2 then
		return ARKINV_G.SLOT_KEY
	elseif id == -1 or id == 0 then
		return ARKINV_G.SLOT_BAG
	end

	local h = GetInventoryItemLink( "player", ContainerIDToInventoryID( id ) )
	
	if h then
	
		local t, s = select( 6, GetItemInfo( h ) )

		if t == ARKINV_L["ITEM_CONTAINER"] then
		
			if s == ARKINV_L["ITEM_CONTAINER_BAG"] then
				return ARKINV_G.SLOT_BAG
			elseif s == ARKINV_L["ITEM_CONTAINER_SOULSHARD"] then
				return ARKINV_G.SLOT_SOULSHARD
			elseif s == ARKINV_L["ITEM_CONTAINER_HERB"] then
				return ARKINV_G.SLOT_HERB
			elseif s == ARKINV_L["ITEM_CONTAINER_ENCHANTING"] then
				return ARKINV_G.SLOT_ENCHANTING
			elseif s == ARKINV_L["ITEM_CONTAINER_ENGINEERING"] then
				return ARKINV_G.SLOT_ENGINEERING
			elseif s == ARKINV_L["ITEM_CONTAINER_GEM"] then
				return ARKINV_G.SLOT_GEM
			elseif s == ARKINV_L["ITEM_CONTAINER_MINING"] then
				return ARKINV_G.SLOT_MINING
			end
			
		elseif t == ARKINV_L["ITEM_QUIVER"] then
		
			if s == ARKINV_L["ITEM_QUIVER_ARROW"] then
				return ARKINV_G.SLOT_PROJECTILE_ARROW
			elseif s == ARKINV_L["ITEM_QUIVER_BULLET"] then
				return ARKINV_G.SLOT_PROJECTILE_BULLET
			end
			
		end
	
		--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		--self:Print( "debug unknown bag type: bagnum=" .. id .. ", type=" .. t .. " (" .. ARKINV_L["ITEM_CONTAINER"] .. ") , subtype=" .. s .. " (" .. ARKINV_L["ITEM_CONTAINER_BAG"] .. ")" )
		return ARKINV_G.SLOT_UNKNOWN
	
	end

	-- empty bag slots
	return ARKINV_G.SLOT_BAG
	
end

function ARKINV:BagScanRequiredAll()

	for _, loc_id in pairs( ARKINV_G.LOCATION ) do
		self:BagScanRequired( loc_id.IDS )
	end

end

function ARKINV:BagScanRequired( bagnum_table )

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " BagScanRequired() start" } )

	local loc_id
	
	for _, bagnum in pairs( bagnum_table ) do
	
		--self:Debug( { date(), " tagging bag ", bagnum, " for rescan" } )
	
		loc_id = self:BagLocation( bagnum )
	
		ARKINV_G.LOCATION[loc_id].rescan[bagnum] = true
		
	end

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " BagScanRequired() end" } )
	
end

function ARKINV:BagScanAll()

	self:Debug( { date(), " BagScanAll() start" } )

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			self:BagScan( bagnum )
		end
	end
	
	self:Debug( { date(), " BagScanAll() end" } )
	
end

function ARKINV:BagScan( bagnum )

	if not ( bagnum ) then
		return
	end

	--self:Debug( { date(), " BagScan( ", bagnum, " ) start" } )

	local loc_id = self:BagLocation( bagnum )
	if not loc_id then
		return
	end

	
	-- check rescan tag
	if not ARKINV_G.LOCATION[loc_id].rescan[bagnum] then
		--self:Debug( { date(), " aborted scan of bag ", bagnum, ", no recorded change" } )
		return
	end

	if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK == false then
		self:Debug( { date(), " aborted scan of bag ", bagnum, ", not at bank" } )
		return
	end


	local tainted = false
	
	local bag = { }
	bag["count"] = GetContainerNumSlots( bagnum )
	bag["empty"] = 0
	bag["type"] = self:BagType( bagnum )
	bag["slot"] = { }
	
	local ob, oi, i, item_id, item_suffix, item_enchant, item_soulbound

	--self:Debug( { "bag ", bagnum, " has ", bag.count, " slots" } )
	
	for slotnum = 1, bag.count do
	
		i = { }
		
		i["h"] = GetContainerItemLink( bagnum, slotnum )
		

		if i.h then
			i["texture"], i["count"] = GetContainerItemInfo( bagnum, slotnum )
			i["name"], _, i["q"] = GetItemInfo( i.h )
			item_id, item_enchant, item_suffix = strmatch( i.h, "|Hitem:(%-?%d+):(%-?%d+):%-?%d+:%-?%d+:%-?%d+:%-?%d+:(%-?%d+):%-?%d+" )

			-- check for soulbound
			if bagnum == -1 then
				-- bank slot
				--self:Debug( { "bag=", bagnum, ", slot=", slotnum, " bank tooltip" } )
				gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) )
			elseif bagnum == -2 then
				-- keyring slot
				--self:Debug( { "bag=", bagnum, ", slot=", slotnum, " keyring tooltip" } )
				gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) )
			else
				--self:Debug( { "bag=", bagnum, ", slot=", slotnum, " standard tooltip" } )
				gt:SetBagItem( bagnum, slotnum )
			end

			if gt:Find( ARKINV_L["TOOLTIP_SOULBOUND"] ) then
				--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " found soulbound in tooltip" )
				i["sb"] = true
				item_soulbound = "1"
			else
				item_soulbound = nil
			end

		else
			-- empty slot

			bag.empty = bag.empty + 1
			
			item_id = nil
			item_enchant = nil
			item_suffix = nil
			item_soulbound = nil

		end

		if not i.name then i.name = "" end
		if not i.count then i.count = 0 end
		if not i.q then i.q = 0 end
		if not item_id then item_id = "0" end
		if not item_suffix then item_suffix = "0" end
		if not item_enchant then item_enchant = "0" end
		if not item_soulbound then item_soulbound = "0" end
		

		i["id"] = item_id .. "." .. item_soulbound .. "." .. item_suffix .. "." .. item_enchant
		
		i["cat"], i["catdef"] = self:ItemCategoryGet( i, bag.type, bagnum, slotnum )
		
		--self:Debug( { "bag=", bagnum, ", slot=", slotnum, ", item=", i.id, ", category=", i.cat, ", default=", i.catdef } )
		
		-- save the data
		bag.slot[slotnum] = i

		

		if not tainted then

			ob = self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum]

			if not ob then
			
				--  bag added
				self:Debug( { date(), " tainted, bag=", bagnum, ", new bag" } )
				tainted = true
				
			else
			
				oi = ob.slot[slotnum]
				
				if not oi then
					--  the old slot doesnt exist - bag increased in size?
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", new slot" } )
					tainted = true
				elseif ( i.h and not oi.h ) then
					-- item added
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", item added" } )
					tainted = true
				elseif ( not i.h and oi.h ) then
					-- item removed
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", item removed" } )
					tainted = true
				elseif ( i.h and oi.h and i.h ~= oi.h ) then
					-- item changed
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", item changed" } )
					tainted = true
				elseif ( i.sb and not oi.sb ) or ( not i.sb and oi.sb ) then
					-- soubound changed
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", soulbound changed" } )
					tainted = true
				elseif ( i.cat and not oi.cat ) or ( not i.cat and oi.cat ) or ( i.cat and oi.cat and i.cat ~= oi.cat ) then
					-- category changed
					self:Debug( { date(), " tainted, bag=", bagnum, ", slot=", slotnum, ", category changed" } )
					tainted = true
				elseif i.count ~= oi.count then
					-- item count changed, not tainted but needs to be refreshed
					ARKINV_G.LOCATION[loc_id].refresh = true
				end
			
			end
			
		end
		
	end

	self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum] = bag
	
	if tainted then
		self:Debug( "tainted, force rebuild" )
		ARKINV_G.LOCATION[loc_id].rebuild = true
	end


	-- reset rescan tag
	ARKINV_G.LOCATION[loc_id].rescan[bagnum] = nil
	
	--self:Debug( { date(), " BagScan( ", bagnum, " ) end" } )
	
end



function ARKINV:CategoryLocationSet( loc_id, category_id, barnum )
	if category_id ~= ARKINV_G.CATEGORY_ID_DEFAULT or barnum then
		self:OptionLocalSet( loc_id, { "category", category_id }, barnum )
	end
end

function ARKINV:CategoryLocationGet( loc_id, category_id )
	-- maps category id's to the bars they are assigned to
	local cat = self:OptionLocalGet( loc_id, { "category", category_id } )
	
	if not cat then
		-- if this category hasn't been assigned to a bar then return the bar that DEFAULT is using
		return self:OptionLocalGet( loc_id, { "category", ARKINV_G.CATEGORY_ID_DEFAULT } ), true
	else
		return cat, false
	end
end

function ARKINV:CategoryHiddenCheck( loc_id, category_id )

	if self:OptionLocalGet( loc_id, { "category", category_id } ) and self:OptionLocalGet( loc_id, { "category", category_id } ) < 0 then
		return true
	else
		return false
	end

end

function ARKINV:CategoryHiddenToggle( loc_id, category_id )
	self:CategoryLocationSet( loc_id, category_id, 0 - self:CategoryLocationGet( loc_id, category_id ) )
end

function ARKINV:CategoryNameGet( category_id )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if category_id == v.id then
			return v.name, false
		end
	end

	local restore = false
	
	if category_id < 0 then
		restore = true
	end
	
	return ( table.concat( { "UNKNOWN CATEGORY: ", category_id } ) ), restore
	
end

function ARKINV:CategoryCustomAddActual( t, name )
	self.db.profile.option.global.category[t][self.db.profile.option.global.category.next] = strtrim( name )
	self.db.profile.option.global.category.next = self.db.profile.option.global.category.next - 1
	self:Print( table.concat( { GREEN_FONT_COLOR_CODE, "Added " .. t .. " category: ", name } ) )
	self:CategoryGenerate()
end

function ARKINV:CategoryCustomAdd( name )
	self:CategoryCustomAddActual( "custom", name )
end

function ARKINV:CategoryPTAdd( name )
	self:CategoryCustomAddActual( "pt", name )
end

function ARKINV:CategoryCustomRestoreActual( t, category_id )
	local name = abs( category_id ) .. " (restored)"
	self.db.profile.option.global.category[t][category_id] = name
	self:Print( GREEN_FONT_COLOR_CODE .. "Restored " .. t .. " category: " .. name )
	self:CategoryGenerate()
end

function ARKINV:CategoryCustomRestore( category_id )
	self:CategoryCustomRestore( "custom", category_id )
end

function ARKINV:CategoryPTRestore( category_id )
	self:CategoryCustomRestore( "pt", category_id )
end

function ARKINV:CategoryCustomRenameActual( t, id, name )
	self:Debug( { "renaming " .. t .. " category ", id, " to [", name, "]" } )
	self.db.profile.option.global.category[t][id] = strtrim( name )
	self:CategoryGenerate()
end

function ARKINV:CategoryCustomRename( id, name )
	self:CategoryCustomRenameActual( "custom", id, name )
end

function ARKINV:CategoryPTRename( id, name )
	self:CategoryCustomRenameActual( "pt", id, name )
end

function ARKINV:CategoryCustomDeleteActual( t, id, confirm )
	if confirm == "confirm" then
		self:Print( table.concat( { GREEN_FONT_COLOR_CODE, "Delete " .. t .. " category successful: ", self.db.profile.option.global.category[t][id], " has been deleted" } ) )
		self.db.profile.option.global.category[t][id] = nil
		self:CategoryGenerate()
		dd:Close()
	else
		self:Print( RED_FONT_COLOR_CODE .. "Delete custom category failed, confirmation not valid" )
	end
end

function ARKINV:CategoryCustomDelete( id, confirm )
	self:CategoryCustomDeleteActual( "custom", id, confirm )
end

function ARKINV:CategoryPTDelete( id, confirm )
	self:CategoryCustomDeleteActual( "pt", id, confirm )
end

function ARKINV:CategoryGenerate()

	categories = {
		[ARKINV_L["CATEGORY_SYSTEM"]] = ARKINV_G.CATEGORY_SYSTEM,
		[ARKINV_L["CATEGORY_PROFESSION"]] = ARKINV_G.CATEGORY_PROFESSION,
		[ARKINV_L["CATEGORY_CLASS"]] = ARKINV_G.CATEGORY_CLASS,
		[ARKINV_L["CATEGORY_EMPTY"]] = ARKINV_G.CATEGORY_EMPTY,
		[ARKINV_L["CATEGORY_CUSTOM"]] = self.db.profile.option.global.category.custom,
		[ARKINV_L["CATEGORY_PT"]] = self.db.profile.option.global.category.pt,
	}
	
	local n
	
	ARKINV_G.CATEGORY = { }

	for t, category in pairs( categories ) do
		for id, name in pairs( category ) do
	
			n = name
			if t == ARKINV_L["CATEGORY_CUSTOM"] then
				n = table.concat( { ARKINV_L["CATEGORY_CUSTOM"], ": ", n } )
			end
			
			if t == ARKINV_L["CATEGORY_PT"] then
				n = table.concat( { ARKINV_L["CATEGORY_PT"], ": ", n } )
			end

			tinsert( ARKINV_G.CATEGORY, { ["id"]=id, ["name"]=n, ["type"]="CATEGORY_" .. t } )
			
		end
	end

end

function ARKINV:CategoryBarInsert( loc_id, barnum )

	for k, v in pairs( self:OptionLocalGet( loc_id, { "category" } ) ) do
		if v >= barnum then
			self:CategoryLocationSet( loc_id, k, self:CategoryLocationGet( loc_id, k ) + 1 )
		end
	end

end

function ARKINV:CategoryBarRemove( loc_id, barnum )

	local def_loc = self:CategoryLocationGet( loc_id, ARKINV_G.CATEGORY_ID_DEFAULT ) -- bar the DEFAULT category is currently on
	
	for k, v in pairs( self:OptionLocalGet( loc_id, { "category" } ) ) do
	
		if v > barnum then
			self:CategoryLocationSet( loc_id, k, self:CategoryLocationGet( loc_id, k ) - 1 )
		elseif v == barnum then
			
			if k == ARKINV_G.CATEGORY_ID_DEFAULT then
				-- if the DEFAULT category was on the bar then move it to bar 1
				self:CategoryLocationSet( loc_id, k, 1 )
			else
				-- erase the location, setting it back to the same as DEFAULT
				self:CategoryLocationSet( loc_id, k, nil )
			end
			
		end
		
	end

end


function ARKINV:ItemCategoryID( cat )

	--self:Debug( { "ItemCategoryID( ", cat, " )" } )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if cat == v.name then
			return v.id
		end
	end
	
	return ARKINV_G.CATEGORY_ID_DEFAULT -- default
	
end

function ARKINV:ItemCategoryGetDefaultOverride( internal_id )

	local id = strmatch( internal_id, "^(%-?%d+)." )
	if not id then
		return nil
	end
	
	local _, class = UnitClass( "player" )

	if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id] then
		-- an override exists

		if type( ARKINV_DEFAULT_CATEGORY_OVERRIDES[id] ) == "string" then
			-- string value means single default category with no other subtypes
			return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id]] )
		end
		
		if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id][class] then
			-- class subtype override
			return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id][class]] )
		end

		for k in self:spairs( ARKINV_G.player_skills, function(a,b) return ARKINV_G.player_skills[a] < ARKINV_G.player_skills[b] end ) do
			-- skill subtype override
			if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id][k] then
				return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id][k]] )
			end
		end

		if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id]["DEFAULT"] then
			-- default override
			return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id]["DEFAULT"]] )
		end

	end

	return nil

end

function ARKINV:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	
	if not i.h then
		-- empty slot
		
		-- self:Debug( "ItemCategoryGetDefault( nil, " .. bt .. " )" )

		--local clump = self.db.profile.option.slot.empty.clump
		loc_id = self:BagLocation( bagnum )
		local clump = self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } )
		
		if bt == ARKINV_G.SLOT_BAG then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_BAG"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_PROJECTILE_BULLET then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_PROJECTILE_ARROW then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_KEY then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_KEY"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_SOULSHARD then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULSHARD"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_SOULSHARD"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_HERB then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_HERB"] )
			end

		end
		
		if bt == ARKINV_G.SLOT_ENCHANTING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENCHANTING"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_ENGINEERING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENGINEERING"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_GEM then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_GEM"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_MINING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_MINING"] )
			end
		
		end
		
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_UNKNOWN"] )
		end

	end

	-- if the value ha been cached then use it
	if not ARKINV_G.CACHE_CATEGORY_DEFAULT[i.id] then
		--self:Debug( { "default", i.id, self:ItemCategoryGetDefaultActual( i, bt, bagnum, slotnum ) } )
		ARKINV_G.CACHE_CATEGORY_DEFAULT[i.id] = self:ItemCategoryGetDefaultActual( i, bt, bagnum, slotnum )
	end
	
	return ARKINV_G.CACHE_CATEGORY_DEFAULT[i.id]

end

function ARKINV:ItemCategoryGetDefaultActual( i, bt, bagnum, slotnum )

	local info_name, _, info_rarity, _, _, info_type, info_subtype, _, info_location = GetItemInfo( i.h )
	
	-- self:Debug( "ItemCategoryGetDefault( " .. h .. ", " .. bt .. " ) info_type=" .. info_type .. ", info_subtype=" .. info_subtype )

	-- does it have a system default category override?
	-- removing internal default categories, relies on periodic table only
--	local dco = self:ItemCategoryGetDefaultOverride( i.id )
--	if dco then
--		return dco
--	end

	
	-- trash, it's always trash
	if info_rarity == 0 then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRASH"] )
	end

	
	-- projectiles
	if info_location == "INVTYPE_AMMO" or info_type == ARKINV_L["ITEM_PROJECTILE"] then
	
		if info_subtype == ARKINV_L["ITEM_PROJECTILE_BULLET"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
		elseif info_subtype == ARKINV_L["ITEM_PROJECTILE_ARROW"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE"] )
		
	end
	
	-- bags / containers
	if info_location == "INVTYPE_BAG" or self:PT_ItemInSets( i.h, "Bag" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONTAINER"] )
	end

	-- soulbound equipment (armour, weapons, trinkets, tabards, etc, etc)
	if i.sb and info_location ~= "" then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"] )
	end

	-- soul shards
	if self:PT_ItemInSets( i.h, "Container.ItemsInType.Soul Shard" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULSHARD"] )
	end

	-- mounts
	if self:PT_ItemInSets( i.h, "Misc.Mount" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
	end

	-- reputation hand-ins
	if self:PT_ItemInSets( i.h, "Reputation.Turnin" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_REPUTATION"] )
	end

	-- quest items
	if info_type == ARKINV_L["ITEM_QUEST"] or self:PT_ItemInSets( i.h, "QuestMats" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_QUEST"] )
	end

	-- keys
	if info_type == ARKINV_L["ITEM_KEY"] or self:PT_ItemInSets( i.h, "Misc.Key" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
	end
	
	-- food
	if self:PT_ItemInSets( i.h, "Consumable.Food.Edible" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_FOOD"] )
	end

	-- drink
	if self:PT_ItemInSets( i.h, "Consumable.Water" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_DRINK"] )
	end

	-- potions (health)
	if 
	self:PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Healing,Consumable.Warlock.Healthstone" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_HEAL"] )
	end
	
	-- potions (mana)
	if self:PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Mana,Consumable.Mage.Mana Stone" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_MANA"] )
	end
	
	-- potions (everything else)
	if self:PT_ItemInSets( i.h, "Consumable.Potion" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION"] )
	end

	-- professions - cycle through the users skills and allocate items to those profressions first
	for k in self:spairs( ARKINV_G.player_skills, function(a,b) return ARKINV_G.player_skills[a] < ARKINV_G.player_skills[b] end ) do
	
		if self:PT_ItemInSets( i.h, ARKINV_L["PT_PROFESSION_" .. k] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_" .. k] )
		end

	end

	-- professions
	for w in string.gmatch( "SKINNING HERBALISM MINING ALCHEMY BLACKSMITHING ENCHANTING ENGINEERING JEWELCRAFTING LEATHERWORKING TAILORING COOKING FIRSTAID FISHING", "%S+" ) do
		if self:PT_ItemInSets( i.h, ARKINV_L["PT_PROFESSION_" .. w] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_" .. w] )
		end
	end

	
	-- class items (this characters class first)
	local pt_class = self.db.account.cache.who[ARKINV_G.ME].class
	if self:PT_ItemInSets( i.h, ARKINV_L["PT_CLASS_" .. pt_class] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_" .. pt_class] )
	end

	-- class items
	for w in string.gmatch( "Druid Hunter Mage Paladin Priest Rogue Shaman Warlock Warrior", "%S+" ) do
		if self:PT_ItemInSets( i.h, "Reagent.Class." .. w ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_" .. string.upper( w )] )
		end
	end


	-- soulbound items that need to be categorised somewhere else other than soulbound
	if i.sb then
	
		-- pets (non combat)
		if self:PT_ItemInSets( i.h, "Misc.Minipet" ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PET_NONCOMBAT"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND"] )
		
	end

	
	-- non soulbound weapons and armour
	if info_location ~= "" then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT"] )
	end

--	if info_type == ARKINV_L["ITEM_ARMOR"] or info_type == ARKINV_L["ITEM_WEAPON"] then
--		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT"] )
--	end


	-- recipes
	if info_type == ARKINV_L["ITEM_RECIPE"] then
		if 1 == 2 then
			-- ignore this for the moment
			for w in string.gmatch( "ALCHEMY BLACKSMITHING COOKING ENCHANTING ENGINEERING FIRSTAID JEWELCRAFTING LEATHERWORKING TAILORING", "%S+" ) do
				if info_subtype == ARKINV_L[w] then
					return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_" .. w] )
				end
			end
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_RECIPE"] )
		end	
	end
	
	
	-- setup tooltip for scanning
	if self:IsTooltipReliable( bagnum ) == false then
		-- offline, build tooltip from itemlink ( why am i trying to figure out a category for things when i'm offline? )
		gt:SetHyperlink( i.h )
	elseif bagnum == -1 then
		-- bank slot
		gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) )
	elseif bagnum == -2 then
		-- keyring slot
		gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) )
	else
		gt:SetBagItem( bagnum, slotnum )
	end


	
	
	
	-- fallback when not in periodic table sets
	
	-- profession requirement (but not armour or weapons) from tooltip
	local _, _, req = gt:Find( ARKINV_L["ITEM_REQUIRES"] )
	if req and not ( info_type == ARKINV_L["ITEM_ARMOR"] or info_type == ARKINV_L["ITEM_WEAPON"] ) then
	
		if strfind( req, ARKINV_L["ALCHEMY"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"] )
		end

		if strfind( req, ARKINV_L["BLACKSMITHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"] )
		end
		
		if strfind( req, ARKINV_L["COOKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_COOKING"] )
		end
		
		if strfind( req, ARKINV_L["ENCHANTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
		end
		
		if strfind( req, ARKINV_L["ENGINEERING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
		end
		
		if strfind( req, ARKINV_L["FIRSTAID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FIRSTAID"] )
		end
		
		if strfind( req, ARKINV_L["FISHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FISHING"] )
		end
		
		if strfind( req, ARKINV_L["HERBALISM"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
		end
		
		if strfind( req, ARKINV_L["JEWELCRAFTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		end
		
		if strfind( req, ARKINV_L["LEATHERWORKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"] )
		end
		
		if strfind( req, ARKINV_L["MINING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
		end
		
		if strfind( req, ARKINV_L["SKINNING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_SKINNING"] )
		end
		
		if strfind( req, ARKINV_L["TAILORING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_TAILORING"] )
		end
		
		if strfind( req, ARKINV_L["RIDING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
		end
		
	end

	-- class via tooltip
	if gt:Find( ARKINV_L["TOOLTIP_CLASS"] ) then

		if gt:Find( ARKINV_L["TOOLTIP_CLASS_DRUID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_DRUID"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_HUNTER"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_HUNTER"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_MAGE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_MAGE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PALADIN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PALADIN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PRIEST"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PRIEST"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_ROGUE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_ROGUE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_SHAMAN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_SHAMAN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARLOCK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARLOCK"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARRIOR"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARRIOR"] )
		end

	end
	
	if info_type == ARKINV_L["ITEM_CONSUMABLE"] then

		if gt:Find( ARKINV_L["TOOLTIP_POTION_HEAL"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_HEAL"] )
		end

		if gt:Find( ARKINV_L["TOOLTIP_POTION_MANA"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_MANA"] )
		end
		
		if gt:Find( ARKINV_L["TOOLTIP_FOOD"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_FOOD"] )
		end
		
		if gt:Find( ARKINV_L["TOOLTIP_DRINK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_DRINK"] )
		end

		if strfind( info_name, ARKINV_L["TOOLTIP_POTION"] ) or strfind( info_name, ARKINV_L["TOOLTIP_ELIXIR"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION"] )
		end
		
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONSUMABLE"] )
		
	end
	
	
	if info_type == ARKINV_L["ITEM_MISCELLANEOUS"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MISCELLANEOUS"] )
	end
	
	if info_type == ARKINV_L["ITEM_REAGENT"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_REAGENT"] )
	end

	if info_type == ARKINV_L["ITEM_TRADEGOODS"] then

		if info_subtype == ARKINV_L["ITEM_TRADEGOODS_DEVICES"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADEGOODS_DEVICES"] )
		elseif info_subtype == ARKINV_L["ITEM_TRADEGOODS_EXPLOSIVES"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADEGOODS_EXPLOSIVES"] )
		elseif info_subtype == ARKINV_L["ITEM_TRADEGOODS_PARTS"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADEGOODS_PARTS"] )
		elseif info_subtype == ARKINV_L["ITEM_TRADEGOODS_GEMS"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADEGOODS"] )
	
	end

	
	-- fallback for any item not categorised
	return self:ItemCategoryID( ARKINV_L["CATEGORY_DEFAULT"] )
	
end

function ARKINV:ItemCategoryGet( i, bt, bagnum, slotnum )
	
	-- returns category, [ default category]
	
	--self:Debug( "ItemCategoryGet() start" )
	
	if not i.h then
	
		--self:Debug( "empty slot" )
		-- empty slot
		return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	end
	
	-- self:Debug( "ItemCategoryGet( " .. h .. ", " .. bt .. " )" )

	-- check custom categories
	if self.db.profile.option.global.category.item[i.id] then
		return self.db.profile.option.global.category.item[i.id], self:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	end
	
	-- check PT categories
	for k, v in self:spairs( self.db.profile.option.global.category.pt, function(a,b) return self.db.profile.option.global.category.pt[a] > self.db.profile.option.global.category.pt[b] end ) do
		if self:PT_ItemInSets( i.h, v ) then
			return k
		end
	end	

	-- return default
	return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	--self:Debug( "ItemCategoryGet() end" )
	
end

function ARKINV:ItemCategorySet( tblItem, category_id )
	-- set cat to nil to reset
	self.db.profile.option.global.category.item[tblItem.id] = category_id
	self:ItemCategoryReload( tblItem )
end

function ARKINV:ItemCategoryReload( tblItem )

	--self:Debug( "ItemCategoryReload() start" )

	local c = nil
	local cd = nil
	
	if tblItem.id then
		for name, who in pairs( self.db.account.cache.who ) do
			for _, loc in pairs( who.loc ) do
				for bagnum, bag in pairs( loc.bag ) do
					for slotnum, slot in pairs( bag.slot ) do
						if slot.id == tblItem.id then
							if not c then
								-- only get the category for the first match, use the same values for the rest
								c, cd = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
							end
							slot["cat"] = c
							slot["catdef"] = cd
						end
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReload() end" )
	
end

function ARKINV:ItemCategoryReloadEmpty()

	--self:Debug( "ItemCategoryReloadEmpty() start" )
	
	for name, who in pairs( self.db.account.cache.who ) do
		for _, loc in pairs( who.loc ) do
			for bagnum, bag in pairs( loc.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					if not slot.h then
						slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadEmpty() end" )
	
end

function ARKINV:ItemCategoryReloadAll()

	--self:Debug( "ItemCategoryReloadAll() start" )

	for name, who in pairs( self.db.account.cache.who ) do
		for _, loc in pairs( who.loc ) do
			for bagnum, bag in pairs( loc.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadAll() end" )
	
end

function ARKINV:ItemCategoryResetDefault()

	for j in pairs( self.db.profile.option.global.category.item ) do
		self.db.profile.option.global.category.item[j] = nil
	end

end

function ARKINV:ReverseName( n )

	local s = { }

	for w in string.gmatch(  n, "%S+" ) do
		tinsert( s, 1, w )
	end

	return table.concat( s, " " )

end

function ARKINV:CalculateBars( loc_id )

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateBars( ", loc_id, " ) start " } )

	local mem = gcinfo()
	
	if not ARKINV_G.LOCATION[loc_id].rebuild then
		self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateBars( ", loc_id, " ) aborted, not needed " } )
	end
	
	
	local current_player = ARKINV_G.LOCATION[loc_id].player
	
	self.db.account.cache.who[current_player].loc[loc_id].bar = { }
	self.db.account.cache.who[current_player].loc[loc_id].bar_count = 1
	
	local barnum

	-- load the inventory into their respective bars
	for bagnum, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
	
		for slotnum, slot in pairs( bag.slot ) do
		
			barnum = self:CategoryLocationGet( loc_id, slot.cat )
			self:Debug( { "loc_id =", loc_id, ", category = ", slot.cat, ", barnum = ", barnum } )
	
			if barnum > 0 or self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) then  -- hidden categories reside on negative bar numbers so they don't get displayed
	
				barnum = abs( barnum )
	
				-- create the bar
				if not self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
					self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 0, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = false }
				end
		
				-- add the item to the bar
				tinsert( self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].item, { ["bag"] = bagnum, ["slot"] = slotnum } )
			
				-- increment the bars item count
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
			
				-- keep track of the last bar used
				if barnum > self.db.account.cache.who[current_player].loc[loc_id].bar_count then
					self.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
				end

				--self:Debug( "bag[" .. bagnum .. "], slot[" .. slotnum .. "], cat[" .. slot.cat .. "], bar[" .. barnum .. "], id=[" .. vb[barnum].id .. "]" )
				
			end
			
		end
		
	end

	
	-- get highest used bar
	local cats = self:OptionLocalGet( loc_id, { "category" } )
	for cat_id, barnum in pairs( cats ) do
		if barnum > self.db.account.cache.who[current_player].loc[loc_id].bar_count then
			self.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
		end
	end
	
	
	-- round up to a full number of bars per row
	self.db.account.cache.who[current_player].loc[loc_id].bar_count = ceil( self.db.account.cache.who[current_player].loc[loc_id].bar_count / self:OptionLocalGet( loc_id, { "bar", "per" } ) ) * self:OptionLocalGet( loc_id, { "bar", "per" } )

	
	-- update the maximum number of bar frames used so far
	if self.db.account.cache.who[current_player].loc[loc_id].bar_count > ARKINV_G.LOCATION[loc_id].bar_max then
		ARKINV_G.LOCATION[loc_id].bar_max = self.db.account.cache.who[current_player].loc[loc_id].bar_count
	end

	
	-- if we're in edit mode then create all missing bars and add a ghost item to every bar
	if ARKINV_G.MODE.EDIT or self:OptionLocalGet( loc_id, { "bar", "showempty" } ) then
	
		self:Debug( "edit mode - adding ghost bars" )
		for barnum = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count do
				
			if not self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
			
				-- create a ghost bar
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 1, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = true }
				
			else
	
				-- add a ghost item to the bar by incrementing the bars item count
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
				
			end
			
		end
		
	end
	
	mem = gcinfo() - mem
	
	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateBars( ", loc_id, " ) end - ", mem } )
	
end

function ARKINV:CalculateContainer( loc_id )

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateContainer( ", loc_id, " ) start " } )

	local mem = gcinfo()

	if not ARKINV_G.LOCATION[loc_id].rebuild then
		self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateContainer( ", loc_id, " ) aborted, not needed " } )
	end


	local current_player = ARKINV_G.LOCATION[loc_id].player

	self.db.account.cache.who[current_player].loc[loc_id].container = { ["row"] = { } }
	
	local bpr = self:OptionLocalGet( loc_id, { "bar", "per" } )
	local rownum = 0
	local bf = 1 -- bar frame, allocated to each bar as it's calculated (uses less frames this way)
	
	self:Debug( { "container has ", self.db.account.cache.who[current_player].loc[loc_id].bar_count, " bars" } )
	self:Debug( { "container set for ", bpr, " bars per row" } )
	
	
	if ARKINV_G.MODE.EDIT == false and self:OptionLocalGet( loc_id, { "bar", "compact" } ) then
	
		-- self:Debug( { "compact bars enabled" } )
	
		local bc = 0  -- number of bars currently in this row
		local vr = { }  -- virtual row - holds a list of bars for this row

		for j = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count do
		
			-- self:Debug( "bar=" .. j )
		
			if self.db.account.cache.who[current_player].loc[loc_id].bar[j] then
				if self.db.account.cache.who[current_player].loc[loc_id].bar[j].count > 0 then
					-- self:Debug( "assignment: bar=" .. j .. ", frame=" .. bf )
					self.db.account.cache.who[current_player].loc[loc_id].bar[j]["frame"] = bf
					bf = bf + 1
					bc = bc + 1
					tinsert( vr, self.db.account.cache.who[current_player].loc[loc_id].bar[j] )
				else
					-- self:Debug( "bar " .. j .. " has no items" )
				end
			else
				-- self:Debug( "bar " .. j .. " does not exist" )
			end
		
			if bc > 0 and ( bc == bpr or j == self.db.account.cache.who[current_player].loc[loc_id].bar_count ) then
		
				rownum = rownum + 1
				if not self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
			
				self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr
				
				-- self:Debug( "row " .. rownum .. " created" )
				
				bc = 0
				vr = { }

			end		
		
		end
	
	else
	
		for j = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count, bpr do
		
			local bc = 0  -- number of bars currently in this row
			local vr = { }  -- virtual row - holds a list of bars for this row

			for b = 1, bpr do
				if self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] then
					if self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1].count > 0 then
						-- self:Debug( "assignment: bar=" .. j+b-1 .. ", frame=" .. bf )
						self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1]["frame"] = bf
						bf = bf + 1
						bc = bc + 1
						tinsert( vr, self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] )
					else
						-- self:Debug( "bar " .. j+b-1 .. " has no items" )
					end
				else
					-- self:Debug( "bar " .. j+b-1 .. " does not exist" )
				end
			end
		
			-- self:Debug( "row " .. rownum .. " allocated " .. bc .. " bars" )
		
			if bc > 0 then
		
				rownum = rownum + 1
				if not self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
			
				self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr

			end

		end
		
	end

	
	-- fit the bars into the row

	local rmw = self:OptionLocalGet( loc_id, { "window", "width" } )  -- row max width
	local rcw = 0 -- row current width
	local rch = 1 -- row current height
	local rmh = 0 -- row max height
		
	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
			
		for bagnum, bar in ipairs( row.bar ) do

			-- self:Debug( "row=" .. rownum .. ", bag=" .. bagnum )
			
			bar.width = floor( bar.count / rmw )
			if bar.width < 1 then
				bar.width = 1
			end
			
			bar.height = ceil( bar.count / bar.width )
				
			if bar.height > rmh then
				rmh = bar.height
			end
				
		end
			
		if rmh > 1 then

			repeat
			
				rcw = 0
				rmh = 0
				rmb = 0
				
				-- find bar with highest height
				for barnum, bar in ipairs( row.bar ) do
					if bar.height > rmh then
						rmh = bar.height
						rmb = barnum
					end
				end

				-- increase that bars width by one
				row.bar[rmb].width = row.bar[rmb].width + 1
				
				-- and recalcualte it's new height
				row.bar[rmb].height = ceil( row.bar[rmb].count / row.bar[rmb].width )
				
				-- and see if that all fits
				rcw = self:tableSum( row.bar, function( a ) return a.width end )
				
				rmh = self:tableMax( row.bar, function( a ) return a.height end )
					
				-- exit if the width fits or the max height is 1
			until rcw >= rmw or rmh == 1
			
		end
			
		--self:Debug( "maximum height for row " .. rownum .. " was " .. rmh )
		for _, bar in pairs( row.bar ) do
			-- set height of all bars in the row to the maximum height used (looks better)
			bar.height = rmh
			
			if bar.ghost or ARKINV_G.MODE.EDIT or self:OptionLocalGet( loc_id, { "bar", "showempty" } ) then
				-- remove the ghost item from the count
				bar.count = bar.count - 1
			end
		end
		
	end
	

	mem = gcinfo() - mem
	
	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " CalculateContainer( ", loc_id, " ) end - ", mem } )

end


function ARKINV:FrameUpdate( loc_id )

	local window = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	
	local current_player = ARKINV_G.LOCATION[loc_id].player
	
	-- update the empty slot count
	local empty = { }
	for k, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
		if not empty[bag.type] then
			empty[bag.type] = { ["count"] = 0, ["empty"] = 0, ["type"] = bag.type }
		end
		empty[bag.type].count = empty[bag.type].count + bag.count
		empty[bag.type].empty = empty[bag.type].empty + bag.empty
	end

	local ee = self:tableSum( empty, function( a ) return a.empty end )
	local ts = self.db.account.cache.who[current_player].loc[loc_id].slot_count
	
	local y = ""
	if ee == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_FULL"]
	else
		y = y .. ee .. "/" .. ts
	end

	if ts == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_NO_DATA"]
	end

	
	if ts ~= 0 and self:tableElements( empty ) > 1 then
		local z = 0
		local x
		y = y .. "  -  "
		for t, e in self:spairs( empty, function(a,b) return empty[a].type < empty[b].type end ) do
			z = z + 1
			--x = e.empty .. "/" .. e.count .. " " .. self:BagTypeText( t )
			x = e.empty .. " " .. self:OptionLocalGet( loc_id, { "slot", "data", t, "name" } )
			if e.empty == 0 then
				x = RED_FONT_COLOR_CODE .. x .. FONT_COLOR_CODE_CLOSE
			end
			
			if z == 1 then
				y = y .. x
			else
				y = y .. ", " .. x
			end
			
		end
	end

	getglobal( window:GetName() .. "StatusText" ):SetText( y )
	
	
	-- set the size of the window
	local h = 0
	h = h + getglobal( window:GetName() .. "Title" ):GetHeight()
	h = h + getglobal( window:GetName() .. "Container" ):GetHeight()
	h = h + getglobal( window:GetName() .. "BagChanger" ):GetHeight()
	h = h + getglobal( window:GetName() .. "Status" ):GetHeight()
	window:SetHeight( h )
	
	window:SetWidth( self.db.account.cache.who[current_player].loc[loc_id].container.width )
	
end

function ARKINV:FramePosition( obj )

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), "FramePosition(", obj:GetName(), ") start" } )

	local mem = gcinfo()

	
	local mem = gcinfo() - mem
	
	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " FramePosition( " .. obj:GetName() .. " ) end " .. mem )
	
end


function ARKINV:GenerateItems( bar, bar_frame )

	--self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateItems( " .. bar_frame:GetName() .. " ) start " )

	local mem = gcinfo()
	
	if bar.count == 0 or bar.ghost then
		return
	end
	
	local parent = bar_frame:GetParent():GetName()
	
	local loc_id = self:UiLocationID( bar_frame:GetName() )

	local current_player = ARKINV_G.LOCATION[loc_id].player

	local i, t


	-- sort the items in the bar
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then
	
		local bagnum, slotnum
		local s = { }
		
		for j = 1, bar.count do
	
			bagnum = bar.item[j].bag
			slotnum = bar.item[j].slot
			
			i = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].slot[slotnum]
	
			-- default sort by bag then slot
			s = { format( "%04i", bagnum ), format( "%04i", slotnum ) }
		
			-- set sort key
			if self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_NAME then
				-- name, bag_type, bag, slot

				if self:OptionLocalGet( loc_id, { "sort", "reversed" } ) then
					tinsert( s, 1, self:ReverseName( i.name ) )
				else
					tinsert( s, 1, i.name )
				end

				if i.name == "" then
					-- sort the empty slots by type
					t = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].type
				else
					t = 0
				end
				tinsert( s, 2, format( "%04i", t ) )

				tinsert( s, 3, format( "%04i", i.count ) )

			end

			
			-- add rarity to start of sort
			if self:OptionLocalGet( loc_id, { "sort", "quality" } ) then
				tinsert( s, 1, format( "%02i", i.q ) )
			end

			-- add location to start of sort
			if self:OptionLocalGet( loc_id, { "sort", "location" } ) then
				if i.h then
					_, _, _, _, _, item_type, item_subtype, _, item_equiploc  = GetItemInfo( i.h )
				else
					item_type = "!"
					item_subtype = "!"
					item_equiploc = "!"
				end
				tinsert( s, 1, item_subtype )
				tinsert( s, 1, item_equiploc )
				tinsert( s, 1, item_type )
			end

			-- add category to start of sort
			if self:OptionLocalGet( loc_id, { "sort", "category" } ) then
				local c = self:CategoryNameGet( i.cat )
				tinsert( s, 1, c )
			end
			
			bar.item[j].sort = table.concat( s, " " )
			
		end
	
		sort( bar.item, function( a, b ) return a.sort > b.sort end )

	end

	local pad_slot = self:OptionLocalGet( loc_id, { "slot", "pad" } )
	local pad_bar = self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
	local col = bar.width
	local obj, locked, readable, bnum
	
	-- build the items in the bar
	for j = 1, bar.count do
	
		i = self.db.account.cache.who[current_player].loc[loc_id].bag[bar.item[j].bag].slot[bar.item[j].slot]
		
		name = self:ContainerItemNameGet( parent, bar.item[j].bag, bar.item[j].slot )
		obj = getglobal( name )
		
		if ARKINV_G.LOCATION[loc_id].rebuild then

			-- anchor first item to bar frame
			if ( j == 1 ) then
				obj:SetPoint( "BOTTOMRIGHT", bar_frame, "BOTTOMRIGHT", 0 - pad_bar, pad_bar )
			else
				if ( mod( ( j - 1 ), col ) == 0 ) then
					-- next row, anchor to first item in previous row
					obj:SetPoint( "BOTTOMRIGHT", self:ContainerItemNameGet( parent, bar.item[j-col].bag, bar.item[j-col].slot ), "TOPRIGHT", 0, pad_slot )
				else
					-- anchor to last one
					obj:SetPoint( "BOTTOMRIGHT", self:ContainerItemNameGet( parent, bar.item[j-1].bag, bar.item[j-1].slot ), "BOTTOMLEFT", 0 - pad_slot, 0 )
				end
			end
	
			SetItemButtonTexture( obj, i.texture )
		
		end
		
		

		SetItemButtonCount( obj, i.count )
	
		-- item locked, needs to only happen for online items
		if not ARKINV_G.LOCATION[loc_id].offline then
			_, _, locked, _, readable = GetContainerItemInfo( bar.item[j].bag, bar.item[j].slot )
			obj.readable = readable
			SetItemButtonDesaturated( obj, locked, 0.5, 0.5, 0.5 )
		else
			obj.readable = false
		end

		
		-- item rarity coloured borders
		if i.q > 0 and self:OptionLocalGet( loc_id, { "slot", "border" } ) then
			local r, g, b = GetItemQualityColor( i.q )
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( r, g, b, 1 )
		else
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( 0.5, 0.5, 0.5, 1 )
		end

		
		if ARKINV_G.LOCATION[loc_id].offline and self:OptionLocalGet( loc_id, { "slot", "fade" } ) then
			obj:SetAlpha( ARKINV_G.FADE_ALPHA )
		else
			obj:SetAlpha( 1 )
		end
		
		
		if i.texture then
			
			getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( 0, 0, 0, 0 )
						
			ContainerFrame_UpdateCooldown( bar.item[j].bag, obj )
			obj.hasItem = 1

		else
			
			-- empty slot
			
			getglobal( obj:GetName() .. "Cooldown"):Hide()
			obj.hasItem = nil
			
			
			if self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) then

				-- icon background
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( "Interface\\Buttons\\UI-EmptySlot-White" )
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexCoord( 0.17, 0.83, 0.17, 0.83 )

			else

				-- slot background colour
				local bt = self.db.account.cache.who[current_player].loc[loc_id].bag[bar.item[j].bag].type
				local colour = self:OptionLocalGet( loc_id, { "slot", "data", bt, "colour" } )
				
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( colour.r, colour.g, colour.b, 0.25 )
				
			end

		end

		obj:Show()
	
	end

	
	
	local mem = gcinfo() - mem
	
	--self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateItems() end - " .. mem )
	
end

function ARKINV:GenerateBarBorder( name )

	local loc_id = self:UiLocationID( name )
	
	local current_player = ARKINV_G.LOCATION[loc_id].player

	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( name .. "Bar" .. bar.frame )
			
			if self:OptionLocalGet( loc_id, { "bar", "border" } ) then
				obj:SetBackdropBorderColor( self:OptionLocalGet( loc_id, { "bar", "colour", "border", "r" } ), self:OptionLocalGet( loc_id, { "bar", "colour", "border", "g" } ), self:OptionLocalGet( loc_id, { "bar", "colour", "border", "b" } ), 1 )
			else
				obj:SetBackdropBorderColor( 0, 0, 0, 0 )
			end
			
			if ARKINV_G.MODE.EDIT then
				obj:SetBackdropBorderColor( 1, 0, 0, 1 )
				getglobal( obj:GetName() .. "Background" ):SetTexture( 1, 0, 0, 0.1 )
				getglobal( obj:GetName() .. "Edit" ):Show()
			else
				getglobal( obj:GetName() .. "Background" ):SetTexture( self:OptionLocalGet( loc_id, { "bar", "colour", "background", "r" } ), self:OptionLocalGet( loc_id, { "bar", "colour", "background", "g" } ), self:OptionLocalGet( loc_id, { "bar", "colour", "background", "b" } ), self:OptionLocalGet( loc_id, { "bar", "colour", "background", "a" } ) )
			end
			
			obj:Show()
		end
	end
	
end



function ARKINV:ContainerGenerateRedrawAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateRedraw( loc_id )
	end
end

function ARKINV:ContainerGenerateRedraw( loc_id )
	ARKINV_G.LOCATION[loc_id].redraw = true
	self:ContainerGenerateRebuild( loc_id )
end


function ARKINV:ContainerGenerateRebuildAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateRebuild( loc_id )
	end
end

function ARKINV:ContainerGenerateRebuild( loc_id )
	ARKINV_G.LOCATION[loc_id].rebuild = true
	ARKINV_G.LOCATION[loc_id].refresh = true
	self:ContainerGenerateActual( loc_id )
end


function ARKINV:ContainerGenerateRefreshAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateRefresh( loc_id )
	end
end

function ARKINV:ContainerGenerateRefresh( loc_id )
	ARKINV_G.LOCATION[loc_id].refresh = true
	self:ContainerGenerateActual( loc_id )
end


function ARKINV:ContainerGenerateAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateActual( loc_id )
	end
end

function ARKINV:ContainerGenerateActual( loc_id )

	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " GenerateContainer( ", loc_id, " ) start" } )
	
	local mem = gcinfo()
	
	
	local frame = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "Container" )

	if not frame then
		self:Debug( { date(), " GenerateContainer( ", loc_id, " ) aborted, no frame found" } )
		return
	end
	
		
	local current_player = ARKINV_G.LOCATION[loc_id].player
	

	-- exit if window isn't displayed
	if not frame:IsVisible() then
		self:Debug( { date(), " GenerateContainer( ", loc_id, " ) aborted, not visible" } )
		return
	end

	
	-- are we online or offline?
	if current_player == ARKINV_G.ME then
		ARKINV_G.LOCATION[loc_id].offline = false
		if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK == false then
			ARKINV_G.LOCATION[loc_id].offline = true
		end
	else
		ARKINV_G.LOCATION[loc_id].offline = true
	end


	
	
	-- hide the changer frame if it's not needed, needs to be done first
	obj = getglobal( frame:GetParent():GetName() .. "BagChanger" )
	if self.db.profile.option.global.framehide.changer or ARKINV_G.LOCATION[loc_id].offline then
		
		obj:Hide()
		obj:SetHeight( 1 )

	else

		if loc_id == ARKINV_G.LOCATION_BAG or ( loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK ) then
			obj:SetHeight( 58 )
			obj:Show()
		end

	end

	
	
	
	-- if bag or bank changer is active then rebuild and redraw is forced on
	if ARKINV_BlizzardPlayerBagChanger:IsVisible() or ARKINV_BlizzardBankBagChanger:IsVisible() then
		self:BagScanRequiredAll()
		ARKINV_G.LOCATION[loc_id].redraw = true
	end

	
	-- rescan all bags
	if not ARKINV_G.LOCATION[loc_id].offline then
		self:BagScanAll()
	end


	-- do we need to refresh or rebuild the window
	if not ARKINV_G.LOCATION[loc_id].rebuild and not ARKINV_G.LOCATION[loc_id].refresh then
		self:Debug( { date(), " GenerateContainer( ", loc_id, " ) aborted, no need" } )
		return
	end
	
	
	-- if instant sort is on then redraw is forced on
	if self:OptionLocalGet( loc_id, { "sort", "instant" } ) or ARKINV_G.MODE.EDIT then
		ARKINV_G.LOCATION[loc_id].redraw = true
	end

	

	
	local obj

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetScale( self:OptionLocalGet( loc_id, { "window", "scale" } ) )

	
	-- set the alpha level (transparency) and border colours for all child frames
	for _, z in pairs( { getglobal( ARKINV_G.GUI_NAME .. loc_id ):GetChildren() } ) do

		if self:OptionLocalGet( loc_id, { "window", "border" } ) then
			z:SetBackdropBorderColor( self:OptionLocalGet( loc_id, { "window", "colour", "border", "r" } ), self:OptionLocalGet( loc_id, { "window", "colour", "border", "g" } ), self:OptionLocalGet( loc_id, { "window", "colour", "border", "b" } ), 1 )
		else
			z:SetBackdropBorderColor( 0, 0, 0, 0 )
		end

		obj = getglobal( z:GetName() .. "Background" )
		if obj then
			obj:SetTexture( self:OptionLocalGet( loc_id, { "window", "colour", "background", "r" } ), self:OptionLocalGet( loc_id, { "window", "colour", "background", "g" } ), self:OptionLocalGet( loc_id, { "window", "colour", "background", "b" } ), self:OptionLocalGet( loc_id, { "window", "colour", "background", "a" } ) )
		end
		
	end


	-- hide the header window if it's not needed
	obj = getglobal( frame:GetParent():GetName() .. "Title" )
	if self.db.profile.option.global.framehide.header then
		obj:Hide()
		obj:SetHeight( 1 )
		getglobal( frame:GetParent():GetName() .. "ContainerOptionMenu" ):Show()
	else
		obj:SetHeight( 40 )
		obj:Show()
		getglobal( frame:GetParent():GetName() .. "ContainerOptionMenu" ):Hide()
	end

	
	-- hide the status window if it's not needed
	obj = getglobal( frame:GetParent():GetName() .. "Status" )
	if self.db.profile.option.global.framehide.status then
		obj:Hide()
		obj:SetHeight( 1 )
	else
		obj:SetHeight( 40 )
		obj:Show()
	end

	-- setup main icon
	getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation0" ):SetNormalTexture( ARKINV_G.LOCATION[loc_id].TEXTURE )
	
	-- setup small icons
	for x in pairs( ARKINV_G.LOCATION ) do
		obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation" .. x )
		obj:SetNormalTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetPushedTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetDisabledTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetHighlightTexture( ARKINV_G.LOCATION[x].TEXTURE )
	end

	
	-- set the current player
	obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleWho" )
	t = { strmatch( current_player, "(.+) %- " ), strmatch( current_player, " %- (.+)" ) }
	
	tinsert( t, 2, ARKINV_G.LOCATION[loc_id].NAME )
	
	if ARKINV_G.LOCATION[loc_id].offline then
		obj:SetTextColor( 1, 0, 0 )
		tinsert( t, 3, ARKINV_L["STATUS_OFFLINE"] )
	else
		obj:SetTextColor( 0, 1, 0 )
	end
	
	if self.db.account.cache.who[current_player].faction then
		tinsert( t, self.db.account.cache.who[current_player].faction )
	end
	
	obj:SetText( table.concat( t, " - " ) )



	
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then

		-- break the inventory up into it's respective bars
		self:CalculateBars( loc_id )

		-- calculate what the container should look like
		self:CalculateContainer( loc_id )

		local name, editlevel
	
	
		-- create (if required) the bar frames, and hide any that are no longer required
		for j = 1, ARKINV_G.LOCATION[loc_id].bar_max do
			name = frame:GetName() .. "Bar" .. j
			obj = getglobal( name )
			if not obj then
				obj = CreateFrame( "Frame", name, frame, "ARVINV_TemplateFrameBar" )
			end
			getglobal( name .. "Edit" ):Hide()
			
			obj:Hide()
		end

		-- calculate numer of active slots (required to keep track of the total number of slots a character has)
		self.db.account.cache.who[current_player].loc[loc_id].slot_count = self:tableSum( self.db.account.cache.who[current_player].loc[loc_id].bag, function( a ) return a.count end )

		-- create (if required) the virtual bags and their item buttons, and hide any that are not currently needed
		for bagnum, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
		
			local bagname = frame:GetName() .. bagnum
			local bagobj = getglobal( bagname )
			if not bagobj then
				bagobj = CreateFrame( "Frame", bagname, frame )
				bagobj:SetWidth( 1 )
				bagobj:SetHeight( 1 )
				bagobj:SetPoint( "TOPLEFT", 0, 0 )
				bagobj:Show()
				bagobj:SetID( bagnum )
			end

			
			-- remember the maximum number of slots used for each bag
			if not ARKINV_G.LOCATION[loc_id].slot_max[bagnum] then
				ARKINV_G.LOCATION[loc_id].slot_max[bagnum] = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count
			else
			
				if self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count > ARKINV_G.LOCATION[loc_id].slot_max[bagnum] then
					ARKINV_G.LOCATION[loc_id].slot_max[bagnum] = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count
				end
			
			end


			for j = 1, ARKINV_G.LOCATION[loc_id].slot_max[bagnum] do
				local itemname = self:ContainerItemNameGet( frame, bagnum, j )
				itemobj = getglobal( itemname )
				
				if not itemobj then
				
					itemobj = CreateFrame( "Button", itemname, bagobj, "ARKINV_TemplateButtonItem" )
					itemobj:SetID( j )
				
					if j == 1 then
						ARKINV_G.BAG_SLOT_SIZE = itemobj:GetWidth()
					end
				
				end	

				if ARKINV_G.MODE.EDIT or ARKINV_G.LOCATION[loc_id].offline then
					-- disable clicks/drag when in edit mode or offline
					itemobj:RegisterForClicks()
					itemobj:RegisterForDrag()
				else
					itemobj:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
					itemobj:RegisterForDrag( "LeftButton" )
				end
	
				itemobj:Hide()
				
			end
			
		end
	

		-- build the bar frames
		local pad_slot = self:OptionLocalGet( loc_id, { "slot", "pad" } )
		local pad_bar_int = self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
		local pad_bar_ext = self:OptionLocalGet( loc_id, { "bar", "pad", "external" } )
		local pad_window = self:OptionLocalGet( loc_id, { "window", "pad" } )
		local anchor = self:OptionLocalGet( loc_id, { "bar", "anchor" } )
		local direction = self:OptionLocalGet( loc_id, { "bar", "direction" } )
		local rmw = 0 -- row max width - each row is not the same width and we need to use the largest when sizing the main window

		self.db.account.cache.who[current_player].loc[loc_id].container.width = 0
		self.db.account.cache.who[current_player].loc[loc_id].container.height = pad_window * 2

		name = frame:GetName()
	
		for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
	
			rmw = pad_window * 2
		
			for barnum, bar in ipairs( row.bar ) do

				obj = getglobal( name .. "Bar" .. bar.frame )
				obj:SetID( bar.id )

				obj:SetWidth( bar.width * ARKINV_G.BAG_SLOT_SIZE + ( bar.width - 1 ) * pad_slot + pad_bar_int * 2 )
				rmw = rmw + obj:GetWidth()
				if barnum > 1 then
					rmw = rmw + pad_bar_ext
				end
				
				obj:SetHeight( bar.height * ARKINV_G.BAG_SLOT_SIZE + ( bar.height - 1 ) * pad_slot + pad_bar_int * 2 )
				
				obj:ClearAllPoints()
				
				-- self:Debug( "row=" .. rownum .. ", bar=" .. barnum .. ", obj=" .. obj:GetName() .. ", frame=" .. bar.frame )
				-- anchor first bar to frame
				if bar.frame == 1 then
				
					if anchor == 1 then
						obj:SetPoint( "BOTTOMRIGHT", name, "BOTTOMRIGHT", 0 - pad_window, pad_window )
					end
					
					if anchor == 2 then
						obj:SetPoint( "BOTTOMLEFT", name, "BOTTOMLEFT", pad_window, pad_window )
					end
					
					if anchor == 3 then
						obj:SetPoint( "TOPLEFT", name, "TOPLEFT", pad_window, 0 - pad_window )
					end
					
					if anchor == 4 then
						obj:SetPoint( "TOPRIGHT", name, "TOPRIGHT", 0 - pad_window, 0 - pad_window )
					end
					
				else
				
					if barnum == 1 then
						-- next row, place under previous row
						-- self:Debug( "anchor=" .. name .. "Bar" .. self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1].frame )
						
						local pbar = name .. "Bar" .. self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1].frame
						
						if anchor == 1 then -- BOTTOM RIGHT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							end
							
						end

						if anchor == 2 then -- BOTTOM LEFT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							end
							
						end
						
						if anchor == 3 then -- TOP LEFT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							end
							
						end

						if anchor == 4 then -- TOP RIGHT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							end
							
							if direction == 2 then
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							end
							
						end

					else
						-- next slot, place bar next to last one
						
						local pbar = name .. "Bar" .. ( bar.frame - 1 )
						
						if anchor == 1 then -- BOTTOM RIGHT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							end
							
						end
						
						if anchor == 2 then -- BOTTOM LEFT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							end
							
						end
						
						if anchor == 3 then -- TOP LEFT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							end
							
						end
						
						if anchor == 4 then -- TOP RIGHT
						
							if direction == 1 then -- HORIZONTAL
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							end
							
							if direction == 2 then -- VERTICAL
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							end
							
						end
						
					end
				
				end
				
			end

			if rmw > self.db.account.cache.who[current_player].loc[loc_id].container.width then
				self.db.account.cache.who[current_player].loc[loc_id].container.width = rmw
			end
		
			self.db.account.cache.who[current_player].loc[loc_id].container.height = self.db.account.cache.who[current_player].loc[loc_id].container.height + obj:GetHeight()

		end

		local x = ( self:tableElements( self.db.account.cache.who[current_player].loc[loc_id].container.row ) or 0 ) - 1
		self.db.account.cache.who[current_player].loc[loc_id].container.height = self.db.account.cache.who[current_player].loc[loc_id].container.height + pad_bar_ext * x

	end
		

	-- display bar borders if required
	self:GenerateBarBorder( frame:GetName() )
	
	
	-- display item icons
	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( frame:GetName() .. "Bar" .. bar.frame )
			self:GenerateItems( bar, obj )
		end
	end

	
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then	
	
		if self.db.account.cache.who[current_player].loc[loc_id].container.height < ARKINV_G.WINDOW_MIN_HEIGHT then
			self.db.account.cache.who[current_player].loc[loc_id].container.height = ARKINV_G.WINDOW_MIN_HEIGHT
		end
		
		if self.db.account.cache.who[current_player].loc[loc_id].container.width < ARKINV_G.WINDOW_MIN_WIDTH then
			self.db.account.cache.who[current_player].loc[loc_id].container.width = ARKINV_G.WINDOW_MIN_WIDTH
		end
		
		frame:SetHeight( self.db.account.cache.who[current_player].loc[loc_id].container.height )
		
		self:FrameUpdate( loc_id )
		
	end
	
	frame = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	self:FramePosition( frame )
	
	-- if instant sort is on then reset the rebuild and refresh options otherwise leave them alone for next time
	if self:OptionLocalGet( loc_id, { "sort", "instant" } ) then
		ARKINV_G.LOCATION[loc_id].rebuild = false
		ARKINV_G.LOCATION[loc_id].refresh = false
	end
	
	ARKINV_G.LOCATION[loc_id].redraw = false
	
	local mem = gcinfo() - mem
	
	self:Debug( { GREEN_FONT_COLOR_CODE, date(), " GenerateContainer( ", loc_id, " ) end - ", mem } )
	
end

function ARKINV:ContainerRestackFindPartial( loc_id, cb, cs, id )

	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		for slotnum = 1, GetContainerNumSlots( bagnum ) do

			if not ( bagnum == cb and slotnum == cs ) then
				
				iLink = GetContainerItemLink( bagnum, slotnum )
				if iLink then

					_, iCount = GetContainerItemInfo( bagnum, slotnum )
					_, _, _, _, _, _, _, iStack = GetItemInfo( iLink )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iID == id and iCount < iStack then
						--self:Print( "found match for partial stack at " .. bagnum .. "." .. slotnum )
						return true, bagnum, slotnum
					end
					
				end
				
			end
			
		end
		
	end

	-- self:Print( "no other partial stacks found" )
	return false

end

function ARKINV:ContainerRestackFindSpecial( loc_id, ct )

	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		local bt = ARKINV:BagType( bagnum )
		
		-- only match items in normal or unknown bags
		if ( bt == ARKINV_G.SLOT_BAG or bt == ARKINV_G.SLOT_UNKNOWN ) then
		
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				iLink = GetContainerItemLink( bagnum, slotnum )
				if iLink and ARKINV_SLOT_TABLE[ct].pt then

					if ARKINV:PT_ItemInSets( iLink, ARKINV_SLOT_TABLE[ct].pt ) then
						--self:Print( "found match for special slot at " .. bagnum .. "." .. slotnum )
						return true, bagnum, slotnum
					end
					
				end
				
			end
			
		end
		
	end

	-- self:Print( "no items found for special slot" )
	return false

end


function ARKINV:ContainerRestack( loc_id )

	-- DO NOT USE CACHED DATA FOR RESTACKING, PULL THE DATA DIRECTLY FROM WOW AGAIN

	-- ARKINV:Print( "ARKINV:ContainerRestack( " .. loc_id .. " )" )

	player = ARKINV_G.LOCATION[loc_id].player
	
	ARKINV:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - compress started" )
	
	changed = true
	
	-- compress stacks
	while changed == true do
		
		changed = false
			
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				-- ARKINV:Print( "checking bag " .. bagnum .. ", slot " .. slotnum )

				while true do

					_, iCount, locked = GetContainerItemInfo( bagnum, slotnum )
					
					if locked then
						-- ARKINV:Print( "yielding - primary is locked" )
						coroutine.yield()
						-- ARKINV:Print( "resumed" )
					else
						break
					end
			
				end

				iLink = GetContainerItemLink( bagnum, slotnum )

				if iLink then
					_, _, _, _, _, _, _, iStack = GetItemInfo( iLink )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iCount < iStack then
				
						-- ARKINV:Print( "partial stack of item " .. iLink .. " found at " .. bagnum .. "." .. slotnum )
						local locked, ok, sb, ss
						
						while true do
					
							ok, sb, ss = ARKINV:ContainerRestackFindPartial( loc_id, bagnum, slotnum, iID )
							
							if ok then
								_, _, locked = GetContainerItemInfo( sb, ss )
							else
								locked = false
							end
						
							if locked then
								-- ARKINV:Print( "yielding - secondary is locked" )
								coroutine.yield()
								-- ARKINV:Print( "resumed" )
							else
								break
							end
							
						end
					
						if ok then
						
							-- ARKINV:Print( "merging with other partial stack of item " .. iID .. " found at " .. sb .. "." .. ss )
							
							ClearCursor()
							PickupContainerItem( bagnum, slotnum )
							PickupContainerItem( sb, ss )
							ClearCursor()
							
							changed = true
						
						end
						
					end
				
				end
					
			end
				
		end
			
	end

	ARKINV:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - compress completed" )

	
	ARKINV:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - restack started" )
	
	-- move items into appropriate bag types with empty slots
	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		local bt = ARKINV:BagType( bagnum )
		-- ARKINV:Print( "bag " .. bagnum .. " = " .. ARKINV_SLOT_TABLE[bt].name )
			
		if not ( bt == ARKINV_G.SLOT_UNKNOWN or bt == ARKINV_G.SLOT_BAG or bt == ARKINV_G.SLOT_KEY ) then
	
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				-- ARKINV:Print( "checking bag " .. bagnum .. " (" .. ARKINV_SLOT_TABLE[bt].name .. "), slot " .. slotnum )

				while true do

					_, _, locked = GetContainerItemInfo( bagnum, slotnum )
					
					if locked then
						-- ARKINV:Print( "yielding - primary is locked" )
						coroutine.yield()
						-- ARKINV:Print( "resumed" )
					else
						break
					end
		
				end

				if not GetContainerItemLink( bagnum, slotnum ) then
					
					local locked, ok, sb, ss
					-- ARKINV:Print( "empty special slot found at " .. bagnum .. "." .. slotnum )
				
					while true do
				
						ok, sb, ss = ARKINV:ContainerRestackFindSpecial( loc_id, bt )
							
						if ok then
							_, _, locked = GetContainerItemInfo( sb, ss )
						else
							locked = false
						end
						
						if locked then
							-- ARKINV:Print( "yielding - secondary is locked" )
							coroutine.yield()
							-- ARKINV:Print( "resumed" )
						else
							break
						end
						
					end
					
					if ok then
						
						-- ARKINV:Print( "moving " .. iLink .. " from " .. sb .. "." .. ss .. " to special slot " .. bagnum .. "." .. slotnum )
						
						ClearCursor()
						PickupContainerItem( sb, ss )
						PickupContainerItem( bagnum, slotnum )
						ClearCursor()

					end
					
				end
			
			end
				
		end
			
	end

	ARKINV:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - restack completed" )

end

function ARKINV:ContainerRestackStart( loc_id )

	if ARKINV_G.LOCATION[loc_id].offline then

		message( "Cannot restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " in offline mode" )
		
	else
	
		if type( ARKINV_G.COROUTINE.RESTACK ) ~= "thread" or coroutine.status( ARKINV_G.COROUTINE.RESTACK ) == "dead" then
	
			-- thread not active, create a new one
			-- ARKINV:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " started" )
			ARKINV_G.COROUTINE.RESTACK = coroutine.create(
				function ()
					ARKINV:ContainerRestack( loc_id )
				end
			)
			coroutine.resume( ARKINV_G.COROUTINE.RESTACK )
			
		else
	
			-- restack already in progress
			ARKINV:Print( RED_FONT_COLOR_CODE .. "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " is already in progress please wait for completion" )
		
		end
		
	end

end

function ARKINV:ContainerRestackResume()

	-- ARKINV:Print( "ARKINV:ContainerRestackResume()" )
	
	if type( ARKINV_G.COROUTINE.RESTACK ) == "thread" and coroutine.status( ARKINV_G.COROUTINE.RESTACK ) == "suspended" then

		-- resume current thread
		coroutine.resume( ARKINV_G.COROUTINE.RESTACK )
		
	end
	
end

function ARKINV:ItemButton_Details()

	local obj = this

	loc_id = ARKINV:UiLocationID( obj:GetName() )
	bagnum = nil
	slotnum = nil
	player = nil
	i = nil

	if loc_id then
		bagnum = obj:GetParent():GetID()
		slotnum = obj:GetID()
		player = ARKINV_G.LOCATION[loc_id].player
		i = self.db.account.cache.who[player].loc[loc_id].bag[bagnum].slot[slotnum]
	end

	return loc_id, bagnum, slotnum, player, i
end


function ARKINV:ItemButton_OnClick( arg1 )

	if ( not IsModifierKeyDown() or IsShiftKeyDown() or IsAutoLootKeyDown() ) then

		local obj = this
	
		local usedmycode = false
		
		local loc_id = ARKINV:ItemButton_Details()
	
		if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
		
			usedmycode = true
			-- do nothing for disabled buttons
			
		end

		if usedmycode == false then
			ContainerFrameItemButton_OnClick( arg1 )
		end

	end

end


function ARKINV:ItemButton_OnEnter()

	local obj = this
	
	-- self:Print( "ARKINV:ItemButton_OnEnter( " .. obj:GetName() .. " )" )
	
	local usedmycode = false

	loc_id, bagnum, slotnum, player, i = ARKINV:ItemButton_Details()
	
	if loc_id and i.h and ( ARKINV_G.LOCATION[loc_id].offline or bagnum == -1 or bagnum == -2 or ARKINV_G.MODE.EDIT ) then

		-- offline, bank, keyring or edit mode
		usedmycode = true
			
		-- position tooltip to the left or right depending on location
		local x
		x = obj:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			GameTooltip:SetOwner( obj, "ANCHOR_LEFT" )
		else
			GameTooltip:SetOwner( obj, "ANCHOR_RIGHT" )
		end

		if ARKINV_G.LOCATION[loc_id].offline then
			-- offline, build tooltip from itemlink
			GameTooltip:SetHyperlink( i.h )
		elseif bagnum == -1 then
			-- bank slot
			GameTooltip:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) )
		elseif bagnum == -2 then
			-- keyring slot
			GameTooltip:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) )
		elseif ARKINV_G.MODE.EDIT then
			GameTooltip:SetBagItem( bagnum, slotnum )
		end

		GameTooltip:Show()

	end
	
	if usedmycode == false then
		ContainerFrameItemButton_OnEnter()
	end

end


function ARKINV:ItemButton_Drag()

	local obj = this

	local usedmycode = false
	
	loc_id, bagnum, slotnum, player, i = ARKINV:ItemButton_Details()

	if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
	
		usedmycode = true
		-- do not drag for disabled buttons
		
	end

	if usedmycode == false then
		ContainerFrameItemButton_OnClick( "LeftButton" )
	end

end


function ARKINV:ItemButton_OnEvent()

	if GameTooltip:IsOwned( this ) then
		ARKINV:ItemButton_OnEnter()
	end

end


function ARKINV:ItemButton_OnUpdate( elapsed )
	
	if ( this.updateTooltip ) then
		this.updateTooltip = this.updateTooltip - elapsed
		if ( this.updateTooltip > 0 ) then
			return
		end
	end

	ARKINV:ItemButton_OnEvent()
	
end


function ARKINV:ItemButton_OnMouseUp( button )

	loc_id, _, _, _, i = ARKINV:ItemButton_Details()
	if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
	
		if IsModifierKeyDown() then
		
			if i.h then
			
				if button == "LeftButton" then
				
					if IsControlKeyDown() then
						DressUpItemLink( i.h )
					elseif IsShiftKeyDown() then
						ChatEdit_InsertLink( i.h )
					end
					
				end
					
			end
			
		else

			if ARKINV_G.MODE.EDIT then
				ARKINV:MenuItemOpen()
			end

		end
		
	end
	
end


function ARKINV:MenuOptionOpen()

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else

		local loc_id = self:UiLocationID( this:GetName() )
	
		local current_player = ARKINV_G.LOCATION[loc_id].player

		local base_options = { type = "group", args = {} }
		dd:InjectAceOptionsTable( self, base_options )

		
	
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					local t = ARKINV_G.PROGRAM_NAME .. " v" .. format( "%.2f", ARKINV_G.PROGRAM_VERSION )
					dd:AddLine( "text", t, "isTitle", true, "textHeight", 14 )
					
					if ARKINV_G.PROGRAM_BETA then
						t = RED_FONT_COLOR_CODE .. "(beta " .. ARKINV_G.PROGRAM_BETA .. ")"
						dd:AddLine( "text", t, "nonClickable", true )
					end

					dd:AddLine()
					
					dd:AddLine( "text", "Switch character",
						"tooltipTitle", "Switch character",
						"tooltipText", "Switches the display to another character",
						"hasArrow", true,
						"value", "CHARACTER"
					)
					
					dd:AddLine()
					
					dd:AddLine(	"text", "Edit Mode",
						"tooltipTitle", "Edit Mode",
						"tooltipText", "toggles edit mode on and off so you can customise which items and categories are displayed on which bars",
						"checked", ARKINV_G.MODE.EDIT,
						"func", function()
							dd:Close()
							self:ToggleEditMode()
						end
					)

					dd:AddLine()
					
					dd:AddLine(	"text", "Use Global Settings",
						"tooltipTitle", "Global Settings",
						"tooltipText", "toggles the use of global settings on and off so you can customise each window separately if required",
						"checked", self.db.profile.option.global.useglobal,
						"func", function()
							self.db.profile.option.global.useglobal = not self.db.profile.option.global.useglobal
							dd:Close()
							self:ContainerGenerateRedrawAll()
						end
					)

					dd:AddLine( "text", "Window",
						"hasArrow", true,
						"value", "WINDOW"
					)
	
					dd:AddLine( "text", "Bars",
						"hasArrow", true,
						"value", "BAR"
					)
					
					dd:AddLine( "text", "Items",
						"hasArrow", true,
						"value", "ITEM"
					)
					
					dd:AddLine( "text", "Sorting",
						"hasArrow", true,
						"value", "SORT"
					)
					
					dd:AddLine()
				
					dd:AddLine( "text", "Custom categories",
						"hasArrow", true,
						"value", "CATEGORY_CUSTOM"
					)
					
					dd:AddLine( "text", "PT categories",
						"hasArrow", true,
						"value", "CATEGORY_PT"
					)
					
					dd:AddLine( "text", "Offline",
						"hasArrow", true,
						"value", "OFFLINE"
					)

					dd:AddLine( "text", "Hidden Frames",
						"hasArrow", true,
						"value", "HIDDEN"
					)
					
					dd:AddLine( "text", "Auto open/close",
						"hasArrow", true,
						"value", "AUTO"
					)
					
					dd:AddLine()
					-- leaves space on the end for the base options
					
				end


				if level == 2 and value then
				
					if value == "CHARACTER" then
					
						dd:AddLine( "text", "SWITCH CHARACTER", "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						if self:tableElements( self.db.account.cache.who ) == 1 then

							dd:AddLine(	"text", "no other character data to choose from",
								"nonClickable", true
							)
		
						else
					
							for k, v in self:spairs( self.db.account.cache.who, function(a,b) return self.db.account.cache.who[a].name < self.db.account.cache.who[b].name end ) do
						
								local n = v.name
								if k == ARKINV_G.ME then
									n = GREEN_FONT_COLOR_CODE .. v.name .. FONT_COLOR_CODE_CLOSE
								end

								if k ~= current_player then
									dd:AddLine(	"text", n,
										"tooltipTitle", "Switch character",
										"tooltipText", "Switches the current display to this character",
										"hasArrow", k ~= ARKINV_G.ME,
										"func", function()
											dd:Close()
											self:ContainerOpen( loc_id, k )
										end,
										"value", ( "CHARMENU" .. k )
									)
								end
							end
					
						end
						
					end
				
					if value == "WINDOW" then
					
						local n = "Window Options"
						if not self.db.profile.option.global.useglobal then
							n = n .. " (" .. GREEN_FONT_COLOR_CODE .. ARKINV_G.LOCATION[loc_id].NAME .. FONT_COLOR_CODE_CLOSE .. ")"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()



						dd:AddLine( "text", "Anchor",
							"tooltipTitle", "Bar anchor point",
							"hasArrow", true,
							"value", "WINDOW_ANCHOR"
						)
						dd:AddLine( "text", "Scale",
							"tooltipTitle", "Scale",
							"tooltipText", "scale the window making it larger or smaller",
							"hasArrow", true,
							"hasSlider", true,
							"sliderIsPercent", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "scale" } ),
							"sliderMin", 0.4,
							"sliderMax", 2,
							"sliderStep", 0.05,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "scale" } ) then
									self:OptionLocalSet( loc_id, { "window", "scale" }, v )
									self:ContainerGenerateRefreshAll()
								end
							end
						)
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Window Padding",
							"tooltipText", "the amount of space to add between the window edge and the bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "pad" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "pad" } ) then
									self:OptionLocalSet( loc_id, { "window", "pad" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "Width",
							"tooltipTitle", "Width",
							"tooltipText", "number of columns to display",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "width" } ),
							"sliderMin", 8,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "width" } ) then
									self:OptionLocalSet( loc_id, { "window", "width" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self:OptionLocalGet( loc_id, { "window", "colour", "background", "r" } ),
							"g", self:OptionLocalGet( loc_id, { "window", "colour", "background", "g" } ),
							"b", self:OptionLocalGet( loc_id, { "window", "colour", "background", "b" } ),
							"opacity", self:OptionLocalGet( loc_id, { "window", "colour", "background", "a" } ),
							"colorFunc", function( r, g, b, a )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "r" }, r )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "g" }, g )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "b" }, b )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "a" }, a )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", "Border",
							"tooltipTitle", "Window Borders",
							"tooltipText", "toggles the display of the borders around the window",
							"checked", self:OptionLocalGet( loc_id, { "window", "border" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "window", "border" }, not self:OptionLocalGet( loc_id, { "window", "border" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						if self:OptionLocalGet( loc_id, { "window", "border" } ) then
							dd:AddLine( "text", "Border Colour",
								"hasColorSwatch", true,
								"r", self:OptionLocalGet( loc_id, { "window", "colour", "border", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "window", "colour", "border", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "window", "colour", "border", "b" } ),
								"colorFunc", function( r, g, b )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "r" }, r )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "g" }, g )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "b" }, b )
									self:ContainerGenerateRefreshAll()
								end
							)
						end
					
					end
					
					if value == "BAR" then
						
						local n = "Bar Options"
						if not self.db.profile.option.global.useglobal then
							n = n .. " (" .. GREEN_FONT_COLOR_CODE .. ARKINV_G.LOCATION[loc_id].NAME .. FONT_COLOR_CODE_CLOSE .. ")"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						dd:AddLine(	"text", "Per Row",
							"tooltipTitle", "Bars per Row",
							"tooltipText", "the number of bars to display in each row",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "per" } ),
							"sliderMin", 1,
							"sliderMax", 8,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "per" } ) then
									self:OptionLocalSet( loc_id, { "bar", "per" }, v )
									self:ContainerGenerateRefreshAll()
								end
							end
						)
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Bar Padding",
							"hasArrow", true,
							"value", "BAR_PADDING"
						)
						dd:AddLine( "text", "Anchor",
							"tooltipTitle", "Bar anchor point",
							"hasArrow", true,
							"value", "BAR_ANCHOR"
						)
						dd:AddLine( "text", "Direction",
							"tooltipTitle", "Bar direction",
							"hasArrow", true,
							"value", "BAR_DIRECTION"
						)
						dd:AddLine( "text", "Compact",
							"tooltipTitle", "Compact",
							"tooltipText", "toggles compact mode",
							"checked", self:OptionLocalGet( loc_id, { "bar", "compact" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "compact" }, not self:OptionLocalGet( loc_id, { "bar", "compact" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "r" } ),
							"g", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "g" } ),
							"b", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "b" } ),
							"opacity", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "a" } ),
							"colorFunc", function( r, g, b, a )
								self:OptionLocalSet( loc_id, { "bar", "colour", "background", "r" }, r )
								self:OptionLocalSet( loc_id, { "bar", "colour", "background", "g" }, g )
								self:OptionLocalSet( loc_id, { "bar", "colour", "background", "b" }, b )
								self:OptionLocalSet( loc_id, { "bar", "colour", "background", "a" }, a )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", "Show empty",
							"tooltipTitle", "Show Empty",
							"tooltipText", "toggles the display of empty bars",
							"checked", self:OptionLocalGet( loc_id, { "bar", "showempty" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "showempty" }, not self:OptionLocalGet( loc_id, { "bar", "showempty" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", "Border",
							"tooltipTitle", "Bar Borders",
							"tooltipText", "toggles the display of a border around each bar",
							"checked", self:OptionLocalGet( loc_id, { "bar", "border" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "border" }, not self:OptionLocalGet( loc_id, { "bar", "border" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						if self:OptionLocalGet( loc_id, { "bar", "border" } ) then
							dd:AddLine( "text", "Border Colour",
								"hasColorSwatch", true,
								"r", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "b" } ),
								"colorFunc", function( r, g, b )
									self:OptionLocalSet( loc_id, { "bar", "colour", "border", "r" }, r )
									self:OptionLocalSet( loc_id, { "bar", "colour", "border", "g" }, g )
									self:OptionLocalSet( loc_id, { "bar", "colour", "border", "b" }, b )
									self:ContainerGenerateRefreshAll()
								end
							)
						end
					
					end
					
					if value == "ITEM" then
					
						local n = "Item Options"
						if not self.db.profile.option.global.useglobal then
							n = n .. " (" .. GREEN_FONT_COLOR_CODE .. ARKINV_G.LOCATION[loc_id].NAME .. FONT_COLOR_CODE_CLOSE .. ")"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Slot Padding",
							"tooltipText", "the amount of space to add between item slots",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "slot", "pad" } ),
							"sliderMin", 1,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if self:OptionLocalGet( loc_id, { "slot", "pad" } ) ~= v then
									self:OptionLocalSet( loc_id, { "slot", "pad" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "Coloured empty slots",
							"tooltipTitle", "Coloured empty slots",
							"tooltipText", "colour empty slot options",
							"hasArrow", self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) == false,
							"value", "EMPTY_COLOUR",
							"checked", self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) == false,
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "empty", "icon" }, not self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", "Clump empty slots",
							"tooltipTitle", "Clump empty slots",
							"tooltipText", "toggles wether empty slots are clumped in together with their non-empty type slots or treated as a seperate category",
							"checked", self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "empty", "clump" }, not self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } ) )
								self:ItemCategoryReloadEmpty()
								self:ContainerGenerateRebuildAll()
							end
						)
						dd:AddLine( "text", "Fade offline",
							"tooltipTitle", "Fade offline",
							"tooltipText", "toggles wether to fade offline items",
							"checked", self:OptionLocalGet( loc_id, { "slot", "fade" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "fade" }, not self:OptionLocalGet( loc_id, { "slot", "fade" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", "Coloured border",
							"tooltipTitle", "Coloured border",
							"tooltipText", "toggles wether to colour the border around each item slot to match it's rarity (Common, Rare, Epic, etc)",
							"checked", self:OptionLocalGet( loc_id, { "slot", "border" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "border" }, not self:OptionLocalGet( loc_id, { "slot", "border" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", "Show hidden",
							"tooltipTitle", "Show hidden",
							"tooltipText", "toggles wether items in hidden categories are shown or not",
							"checked", self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "ignorehidden" }, not self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)
		
						dd:AddLine()
						
						dd:AddLine( "text", "Restack",
							"tooltipTitle", "Restack",
							"tooltipText", "Restacks your inventory",
							"func", function()
								dd:Close()
								ARKINV:ContainerRestackStart( loc_id )
							end
						)
		
					end
					
					if value == "SORT" then

						local n = "Sort Options"
						if not self.db.profile.option.global.useglobal then
							n = n .. " (" .. GREEN_FONT_COLOR_CODE .. ARKINV_G.LOCATION[loc_id].NAME .. FONT_COLOR_CODE_CLOSE .. ")"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						dd:AddLine( "text", "By Name",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								if self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME then
									self:OptionLocalSet( loc_id, { "sort", "type" }, ARKINV_G.SLOT_SORT_NAME )
									self:ContainerGenerateRebuildAll()
								end
							end
						)

						dd:AddLine( "text", "By Bag / Slot",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_BAGSLOT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_BAGSLOT then
									self:OptionLocalSet( loc_id, { "sort", "type" }, ARKINV_G.SLOT_SORT_BAGSLOT )
									self:ContainerGenerateRebuildAll()
								end
							end
						)


						dd:AddLine()
						
						dd:AddLine( "text", "Use reversed names",
							"tooltipTitle", "Use reversed names in sort",
							"tooltipText", "toggles the sorting of items by reversed names",
							"checked", self:OptionLocalGet( loc_id, { "sort", "reversed" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "reversed" }, not self:OptionLocalGet( loc_id, { "sort", "reversed" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)
						dd:AddLine( "text", "Include rarity",
							"tooltipTitle", "Include rarity in sort",
							"tooltipText", "toggles the sorting of items by rarity",
							"checked", self:OptionLocalGet( loc_id, { "sort", "quality" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "quality" }, not self:OptionLocalGet( loc_id, { "sort", "quality" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)
						dd:AddLine( "text", "Include location",
							"tooltipTitle", "Include location in sort",
							"tooltipText", "toggles the sorting of items by equipment location",
							"checked", self:OptionLocalGet( loc_id, { "sort", "location" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "location" }, not self:OptionLocalGet( loc_id, { "sort", "location" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)
						dd:AddLine( "text", "Include category",
							"tooltipTitle", "Include category in sort",
							"tooltipText", "toggles the sorting of items by category",
							"checked", self:OptionLocalGet( loc_id, { "sort", "category" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "category" }, not self:OptionLocalGet( loc_id, { "sort", "category" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)

						dd:AddLine()
						
						dd:AddLine(	"text", "Instant",
							"tooltipTitle", "Instant",
							"tooltipText", "toggles instant sort mode on and off. on means re-sorting is done when something changes, off means sorting is only done when the window is opened",
							"checked", self:OptionLocalGet( loc_id, { "sort", "instant" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "instant" }, not self:OptionLocalGet( loc_id, { "sort", "instant" } ) )
								self:ContainerGenerateRebuildAll()
							end
						)
						
					end
					
					if value == "CATEGORY_CUSTOM" then
					
						dd:AddLine( "text", "CATEGORY OPTIONS: " .. ARKINV_L["CATEGORY_CUSTOM"], "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						
						dd:AddLine( "text", "Add new",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryCustomAdd( v )
							end
						)
						
						dd:AddLine()
						
						for k, v in self:spairs( self.db.profile.option.global.category.custom, function(a,b) return self.db.profile.option.global.category.custom[a] < self.db.profile.option.global.category.custom[b] end ) do
							dd:AddLine( "text", v,
								"hasArrow", true,
								"value", ( "CATEGORY_CUSTOM_" .. k )
							)
						end
					end
					
					if value == "CATEGORY_PT" then
					
						dd:AddLine( "text", "CATEGORY OPTIONS: " .. ARKINV_L["CATEGORY_PT"], "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						
						dd:AddLine( "text", "Add new",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryPTAdd( v )
							end
						)
						
						dd:AddLine()
						
						for k, v in self:spairs( self.db.profile.option.global.category.pt, function(a,b) return self.db.profile.option.global.category.pt[a] < self.db.profile.option.global.category.pt[b] end ) do
							dd:AddLine( "text", v,
								"hasArrow", true,
								"value", ( "CATEGORY_PT_" .. k )
							)
						end
					end
					
					if value == "OFFLINE" then

						dd:AddLine( "text", "OFFLINE OPTIONS", "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						
						dd:AddLine( "text", "Bags & Keyring",
							"tooltipTitle", "Bags & Keyring",
							"tooltipText", "remember bag and keyring data so you can view it while on another character.  change will take effect next login/logout",
							"checked", self.db.profile.option.global.remember.alt,
							"func", function()
								self.db.profile.option.global.remember.alt = not self.db.profile.option.global.remember.alt
							end
						)
						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Bank",
							"tooltipText", "remember bank data so you can view it while 'offline' or on another character.  change will take effect next login/logout",
							"checked", self.db.profile.option.global.remember.bank,
							"func", function()
								self.db.profile.option.global.remember.bank = not self.db.profile.option.global.remember.bank
							end
						)

					
					end
					
					if value == "HIDDEN" then

						dd:AddLine( "text", "HIDDEN FRAMES", "isTitle", true, "textHeight", 12 )
					
						dd:AddLine()
						
						dd:AddLine( "text", "Title",
							"tooltipTitle", "Hide the " .. ARKINV_G.PROGRAM_NAME .. " Title frame",
							"tooltipText", "toggles wether the " .. ARKINV_G.PROGRAM_NAME .. " title frame (the one at the top) is hidden",
							"checked", self.db.profile.option.global.framehide.header,
							"func", function()
								dd:Close()
								self.db.profile.option.global.framehide.header = not self.db.profile.option.global.framehide.header
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine( "text", "Bag Changer",
							"tooltipTitle", "Hide the " .. ARKINV_G.PROGRAM_NAME .. " BagChanger frame",
							"tooltipText", "toggles wether the " .. ARKINV_G.PROGRAM_NAME .. " BagChanger frame (the one with your bag slots) is hidden",
							"checked", self.db.profile.option.global.framehide.changer,
							"func", function()
								dd:Close()
								self:ToggleBagChanger()
							end
						)
						
						dd:AddLine( "text", "Status",
							"tooltipTitle", "Hide the " .. ARKINV_G.PROGRAM_NAME .. " Status frame",
							"tooltipText", "toggles wether the " .. ARKINV_G.PROGRAM_NAME .. " status frame (the one with the empty slot count and gold) is hidden",
							"checked", self.db.profile.option.global.framehide.status,
							"func", function()
								self.db.profile.option.global.framehide.status = not self.db.profile.option.global.framehide.status
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine()
						
						dd:AddLine( "text", "Blizzard",
							"tooltipTitle", "Hide the Blizzard frames",
							"tooltipText", "toggles wether the Blizzard Bank and Bag frames are hidden",
							"checked", self.db.profile.option.global.framehide.blizzard,
							"func", function()
								self.db.profile.option.global.framehide.blizzard = not self.db.profile.option.global.framehide.blizzard
								self:HookBlizzardAPI()
							end
						)

						
					end
					
					if value == "AUTO" then
					
						dd:AddLine( "text", "Auto open",
							"hasArrow", true,
							"value", "AUTO_OPEN"
						)
						dd:AddLine( "text", "Auto close",
							"hasArrow", true,
							"value", "AUTO_CLOSE"
						)

					end
					
				end


				if level == 3 and value then
				
					if strsub( value, 1, 8 ) == "CHARMENU" then
						local k = strmatch( value, "CHARMENU(.+)" )
						
						dd:AddLine(	"text", RED_FONT_COLOR_CODE .. "Erase all cached data",
							"tooltipTitle", "Erase cached data",
							"tooltipText", RED_FONT_COLOR_CODE .. "Erases all cached data for character " .. k,
							"func", function()
								dd:Close()
								self.db.account.cache.who[k] = nil
								ARKINV_G.LOCATION[loc_id].player = ARKINV_G.ME
								self:ContainerCloseAll()
								self:ContainerGenerateRebuild( loc_id )
							end
						)	
						
					end
				
					if value == "WINDOW_ANCHOR" then
						dd:AddLine( "text", "BOTTOMRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == 1,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= 1 then
									self:AnchorSet( loc_id, 1 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "BOTTOMLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == 2,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= 2 then
									self:AnchorSet( loc_id, 2 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == 3,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= 3 then
									self:AnchorSet( loc_id, 3 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == 4,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= 4 then
									self:AnchorSet( loc_id, 4 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
					
					if value == "BAR_PADDING" then
						dd:AddLine( "text", "Internal",
							"tooltipTitle", "Internal Padding",
							"tooltipText", "the amount of space to add between the bars and the items",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } ) then
									self:OptionLocalSet( loc_id, { "bar", "pad", "internal" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "External",
							"tooltipTitle", "External Padding",
							"tooltipText", "the amount of space to add between bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "pad", "external" } ),
							"sliderMin", 0,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "pad", "external" } ) then
									self:OptionLocalSet( loc_id, { "bar", "pad", "external" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
				
					if value == "BAR_ANCHOR" then
						dd:AddLine( "text", "BOTTOMRIGHT",
							"tooltipTitle", "Bar anchor point",
							"tooltipText", "anchors the bars in the bottom right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == 1,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= 1 then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, 1 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "BOTTOMLEFT",
							"tooltipTitle", "Bar anchor point",
							"tooltipText", "anchors the bars in the bottom left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == 2,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= 2 then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, 2 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPLEFT",
							"tooltipTitle", "Bar anchor point",
							"tooltipText", "anchors the bars in the top left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == 3,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= 3 then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, 3 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPRIGHT",
							"tooltipTitle", "Bar anchor point",
							"tooltipText", "anchors the bars in the top right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == 4,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= 4 then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, 4 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
				
					if value == "BAR_DIRECTION" then
						dd:AddLine( "text", "HORIZONTAL",
							"tooltipTitle", "Bar direction",
							"tooltipText", "extends the bars horizontally",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "direction" } ) == 1,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "direction" } ) ~= 1 then
									self:OptionLocalSet( loc_id, { "bar", "direction" }, 1 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "VERTICAL",
							"disabled", true,
							"tooltipTitle", "Bar direction",
							"tooltipText", "extends the bars vertically",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "direction" } ) == 2,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "direction" } ) ~= 2 then
									self:OptionLocalSet( loc_id, { "bar", "direction" }, 2 )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end

					if value == "AUTO_OPEN" then

						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the bank",
							"checked", self.db.profile.option.global.auto.open.bank,
							"func", function()
								self.db.profile.option.global.auto.open.bank = not self.db.profile.option.global.auto.open.bank
							end
						)
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the mailbox",
							"checked", self.db.profile.option.global.auto.open.mail,
							"func", function()
								self.db.profile.option.global.auto.open.mail = not self.db.profile.option.global.auto.open.mail
							end
						)
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you talk to a merchant",
							"checked", self.db.profile.option.global.auto.open.merchant,
							"func", function()
								self.db.profile.option.global.auto.open.merchant = not self.db.profile.option.global.auto.open.merchant
							end
						)
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open a trade",
							"checked", self.db.profile.option.global.auto.open.trade,
							"func", function()
								self.db.profile.option.global.auto.open.trade = not self.db.profile.option.global.auto.open.trade
							end
						)
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the auction house",
							"checked", self.db.profile.option.global.auto.open.auction,
							"func", function()
								self.db.profile.option.global.auto.open.auction = not self.db.profile.option.global.auto.open.auction
							end
						)
					
					end
					
					if value == "AUTO_CLOSE" then
					
						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the bank",
							"checked", self.db.profile.option.global.auto.close.bank,
							"func", function()
								self.db.profile.option.global.auto.close.bank = not self.db.profile.option.global.auto.close.bank
							end
						)
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the mailbox",
							"checked", self.db.profile.option.global.auto.close.mail,
							"func", function()
								self.db.profile.option.global.auto.close.mail = not self.db.profile.option.global.auto.close.mail
							end
						)
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave a merchant",
							"checked", self.db.profile.option.global.auto.close.merchant,
							"func", function()
								self.db.profile.option.global.auto.close.merchant = not self.db.profile.option.global.auto.close.merchant
							end
						)
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you close a trade",
							"checked", self.db.profile.option.global.auto.close.trade,
							"func", function()
								self.db.profile.option.global.auto.close.trade = not self.db.profile.option.global.auto.close.trade
							end
						)
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the auction house",
							"checked", self.db.profile.option.global.auto.close.auction,
							"func", function()
								self.db.profile.option.global.auto.close.auction = not self.db.profile.option.global.auto.close.auction
							end
						)
						dd:AddLine( "text", "Combat",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you enter combat",
							"checked", self.db.profile.option.global.auto.close.combat,
							"func", function()
								self.db.profile.option.global.auto.close.combat = not self.db.profile.option.global.auto.close.combat
							end
						)
						
					end
					
					if value == "EMPTY_COLOUR" then
					
						dd:AddLine( "text", "EMPTY SLOT COLOURS", "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						for k, v in self:spairs( self:OptionLocalGet( loc_id, { "slot", "data" } ), function(a,b) return self:OptionLocalGet( loc_id, { "slot", "data", a, "long" } ) < self:OptionLocalGet( loc_id, { "slot", "data", b, "long" } ) end ) do
							dd:AddLine( "text", v.long,
								"hasColorSwatch", true,
								"r", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "b" } ),
								"colorFunc", function( r, g, b )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "r" }, r )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "g" }, g )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "b" }, b )
									self:ContainerGenerateRefreshAll()
								end
							)
						end

					end

					if strsub( value, 1, 16 ) == "CATEGORY_CUSTOM_" then
						
						local cat_id = tonumber( strmatch( value, "CATEGORY_CUSTOM_(.+)" ) )
						local cat_name = strmatch( self:CategoryNameGet( cat_id ), ARKINV_L["CATEGORY_CUSTOM"] .. ": (.*)" )
						
						dd:AddLine( "text", "Rename " .. cat_name .. " to",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxText", cat_name,
							"editBoxFunc", function( v )
								self:CategoryCustomRename( cat_id, v )
							end
						)


						dd:AddLine( "text", "Delete " .. cat_name,
							"tooltipTitle", "Delete a category",
							"tooltipText", "deletes a category.  you must enter the word 'confirm' to actually delete the category",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryCustomDelete( cat_id, v )
							end
						)
						
					end
				
					if strsub( value, 1, 12 ) == "CATEGORY_PT_" then
						
						local cat_id = tonumber( strmatch( value, "CATEGORY_PT_(.+)" ) )
						local cat_name = strmatch( self:CategoryNameGet( cat_id ), ARKINV_L["CATEGORY_PT"] .. ": (.*)" )
						
						dd:AddLine( "text", "Rename " .. cat_name .. " to",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxText", cat_name,
							"editBoxFunc", function( v )
								self:CategoryPTRename( cat_id, v )
							end
						)

						dd:AddLine( "text", "Delete " .. cat_name,
							"tooltipTitle", "Delete a category",
							"tooltipText", "deletes a category.  you must enter the word 'confirm' to actually delete the category",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryPTDelete( cat_id, v )
							end
						)
						
					end
				
				end
				
				-- try to add the base options (will fail where it's not supposed to exist so this is safe to use this way albeit crude)
				dd:FeedAceOptionsTable( base_options )
				
				if level == 1 then
				
					dd:AddLine()
					
					dd:AddLine( "text", "Close Menu",
						"func", function()
							dd:Close()
						end
					)

				end

			end
			
		)

	end
	
end

function ARKINV:MenuBarOpen()

	if dd:IsOpen( this ) then

		dd:Close()
		
	else

		local loc_id = self:UiLocationID( this:GetName() )
		local current_player = ARKINV_G.LOCATION[loc_id].player
		local barnum = this:GetParent():GetID()
		
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		local cat_type = {
			[1] = ARKINV_L["CATEGORY_SYSTEM"],
			[2] = ARKINV_L["CATEGORY_PROFESSION"],
			[3] = ARKINV_L["CATEGORY_CLASS"],
			[4] = ARKINV_L["CATEGORY_EMPTY"],
			[5] = ARKINV_L["CATEGORY_CUSTOM"],
			[6] = ARKINV_L["CATEGORY_PT"],
		}
		
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					dd:AddLine( "text", "BAR " .. barnum, "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()
					dd:AddLine( "text", "Currently Assigned:", "isTitle", true )
			
					for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
						cat_bar, def_bar = self:CategoryLocationGet( loc_id, cat.id )
					
						if not def_bar and abs( cat_bar ) == barnum then
						
							local t = cat.type
							local n = cat.name
							local c = GREEN_FONT_COLOR_CODE
							if cat_bar < 0 then
								c = RED_FONT_COLOR_CODE
							end
							
							-- assigned categories for this bar - displayed in green, hidden displayed in red
							dd:AddLine( "text", c .. n .. FONT_COLOR_CODE_CLOSE,
								"hasArrow", cat.id ~= 0,
								"value", "ASSIGNED_" .. cat.id
							)

						end
						
					end

					dd:AddLine()
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true )
					
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"value", "CATEGORY_" .. v
						)
					end
					
					
					dd:AddLine()
					
					dd:AddLine( "text", "Insert empty bar",
						"tooltipTitle", "Insert empty bar",
						"tooltipText", "inserts an empty bar here moving all categories up one bar",
						"func", function()
							dd:Close()
							self:CategoryBarInsert( loc_id, barnum )
							self:ContainerGenerateRebuildAll()
						end
					)
					dd:AddLine( "text", "Remove this bar",
						"tooltipTitle", "Remove this bar",
						"tooltipText", "removes this bar, placing all currently assigned categories back to the default bar and moving all others down one bar",
						"func", function()
							dd:Close()
							self:CategoryBarRemove( loc_id, barnum )
							self:ContainerGenerateRebuildAll()
						end
					)
					
					dd:AddLine()
					
					dd:AddLine( "text", "Close Menu",
						"func", function()
							dd:Close()
						end
					)
					
				end
				
				
				if level == 2 and value then

					local k = strmatch( value, "ASSIGNED_(.*)" )
				
					if k then
					
						category_id = tonumber( k )
						
						dd:AddLine( "text", self:CategoryNameGet( category_id ), "isTitle", true, "textHeight", 12 )
						
						dd:AddLine()

						dd:AddLine( "text", "Remove",
							"tooltipTitle", "Remove",
							"tooltipText", "click to remove " .. self:CategoryNameGet( category_id ) .. " from bar " .. barnum .. " and return it to the default bar",
							"func", function()
								dd:Close()
								self:CategoryLocationSet( loc_id, category_id, nil )
								self:ContainerGenerateRebuildAll()
							end
						)

						dd:AddLine( "text", "Hidden",
							"tooltipTitle", "Hidden",
							"tooltipText", "click to toggle this categories hidden status.  items in a hidden category will not display in normal mode",
							"checked", self:CategoryHiddenCheck( loc_id, category_id ),
							"func", function()
								self:CategoryHiddenToggle( loc_id, category_id )
								self:ContainerGenerateRebuildAll()
							end
						)
						
					end

				
					local k = strmatch( value, "CATEGORY_(.*)" )
					
					if k then
					
						dd:AddLine( "text", k, "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do

							local t = cat.type
							local cat_bar, def_bar = self:CategoryLocationGet( loc_id, cat.id )
							
							if abs( cat_bar ) == barnum and not def_bar then
								t = "IGNORE" -- change the category so it doesn't display
							end

							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							local n = cat.name

							if value == t then

								if not def_bar then
									-- category is assigned to a bar - show the user where
									n = LIGHTYELLOW_FONT_COLOR_CODE .. n .. "  - " .. self:CategoryLocationGet( loc_id, cat.id ) .. FONT_COLOR_CODE_CLOSE
								end

								dd:AddLine( "text", n,
									"tooltipTitle", "Category",
									"tooltipText", "Assign category " .. cat.name .. " to this bar",
									"func", function()
										self:CategoryLocationSet( loc_id, cat.id, barnum )
										self:ContainerGenerateRebuildAll()
									end
								)
							end

						end
					
					end

				end

			end
		)

	end
	
end

function ARKINV:MenuItemOpen()

	if ARKINV_G.MODE.EDIT == false then
		return
	end

	
	local loc_id = self:UiLocationID( this:GetName() )
	
	local current_player = ARKINV_G.LOCATION[loc_id].player

	
	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		local bagnum = this:GetParent():GetID()
		local slotnum = this:GetID()
		local i = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].slot[slotnum]
		
		local _, _, _, ic = GetItemQualityColor( i.q )
		local barnum = abs( self:CategoryLocationGet( loc_id, i.cat ) )
		
		local cat_type = {
			[1] = ARKINV_L["CATEGORY_SYSTEM"],
			[2] = ARKINV_L["CATEGORY_PROFESSION"],
			[3] = ARKINV_L["CATEGORY_CLASS"],
			[4] = ARKINV_L["CATEGORY_EMPTY"],
			[5] = ARKINV_L["CATEGORY_CUSTOM"],
		}
	
	
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", ARKINV_L["MENU_OPTIONS_ITEM_OPTIONS_TITLE"] .. ":", "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()
					
					dd:AddLine( "text", ic .. i.name .. FONT_COLOR_CODE_CLOSE, "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()


					if not i.catdef then
						dd:AddLine( "text", "Default assignment: " .. GREEN_FONT_COLOR_CODE .. self:CategoryNameGet( i.cat ) .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						)
					else
						local _, cat_restore = self:CategoryNameGet( i.cat )
						dd:AddLine( "text", "Current assignment: " .. GREEN_FONT_COLOR_CODE .. self:CategoryNameGet( i.cat ) .. FONT_COLOR_CODE_CLOSE,
							"hasArrow", cat_restore,
							"value", "RESTORE"
						)
						dd:AddLine( "text", "Default assignment: " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:CategoryNameGet( i.catdef ) .. FONT_COLOR_CODE_CLOSE,
							"tooltipTitle", "Reset to default",
							"tooltipText", "click to reset the category for this item back to it's default value",
							"func", function()
								dd:Close()
								self:ItemCategorySet( i, nil )
								self:ContainerGenerateRebuildAll()
							end
						)
					end
				
					dd:AddLine()
					
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true )
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"tooltipTitle", "Assign Category",
							"tooltipText", "assign this item to a specific category",
							"value", "CATEGORY_" .. v
						)
					end
					
					dd:AddLine()
					
					dd:AddLine(	"text", "Move " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:CategoryNameGet( i.cat ) .. FONT_COLOR_CODE_CLOSE .. " to Bar",
						"hasArrow", true,
						"hasSlider", true,
						"sliderValue", self:CategoryLocationGet( loc_id, i.cat ),
						"sliderMin", 1,
						"sliderMax", self.db.account.cache.who[current_player].loc[loc_id].bar_count + 1,
						"sliderStep", 1,
						"sliderFunc", function( v )
							if self:CategoryLocationGet( loc_id, i.cat ) ~= v then
								self:CategoryLocationSet( loc_id, i.cat, v )
								self:ContainerGenerateRebuildAll()
							end
						end
					)

					dd:AddLine()
					
					dd:AddLine( "text", "Debug Info",
						"hasArrow", true,
						"value", "DEBUG"
					)
					
					dd:AddLine()
					
					dd:AddLine( "text", "Close Menu",
						"func", function()
							dd:Close()
						end
					)
					
				end

				if level == 2 then

					if value and strsub( value, 1, 9 ) == "CATEGORY_" then
					
						for _, v in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
							local t = v.type
							if v.id == i.cat then
								t = "CATEGORY_HIDDEN"
							end
							
							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							if value == t then
							
								dd:AddLine( "text", v.name,
									"tooltipTitle", "Assign Category",
									"tooltipText", "assign this item to the " .. v.name .. " category",
									"func", function()
										dd:Close()
										self:ItemCategorySet( i, v.id )
										self:ContainerGenerateRebuildAll()
									end
								)
							
							end
							
						end
						
					end
					
					if value == "DEBUG" then
					
						dd:AddLine( "text", "Bag: " .. GREEN_FONT_COLOR_CODE .. bagnum )
						dd:AddLine( "text", "Slot: " .. GREEN_FONT_COLOR_CODE .. slotnum )
						dd:AddLine()
						dd:AddLine( "text", "AI ID: " .. GREEN_FONT_COLOR_CODE .. i.id )
						dd:AddLine( "text", "AI Category: " .. GREEN_FONT_COLOR_CODE .. i.cat )
			
						if i.h then
							
							local inam, _, irar, ilvl, imin, ityp, isub, icount, iloc, itxt = GetItemInfo( i.h )
							
							dd:AddLine()
							dd:AddLine( "text", "Name: " .. GREEN_FONT_COLOR_CODE .. inam )
							local ilnk = strmatch( i.h, "(%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+)" )
							dd:AddLine( "text", "ID: " .. GREEN_FONT_COLOR_CODE .. ilnk )
							dd:AddLine( "text", "Rarity: " .. GREEN_FONT_COLOR_CODE .. irar )
							dd:AddLine( "text", "Level: " .. GREEN_FONT_COLOR_CODE .. ilvl )
							dd:AddLine( "text", "Min Level: " .. GREEN_FONT_COLOR_CODE .. imin )
							dd:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. ityp )
							dd:AddLine( "text", "Sub Type: " .. GREEN_FONT_COLOR_CODE .. isub )
							dd:AddLine( "text", "Stack Count: " .. GREEN_FONT_COLOR_CODE .. icount )
							dd:AddLine( "text", "Location: " .. GREEN_FONT_COLOR_CODE .. iloc )
							dd:AddLine( "text", "Texture: " .. GREEN_FONT_COLOR_CODE .. itxt )
							
						end
					
					
					
					
					end
					
					if value == "RESTORE" then
					
						dd:AddLine( "text", "Restore",
							"tooltipTitle", "Restore",
							"tooltipText", "click to restore this deleted custom category",
							"func", function()
								dd:Close()
								self:CategoryCustomRestore( i.cat )
								self:ContainerGenerateRebuildAll()
							end
						)
					end
					
				end

			end
		)
		
	end
	
end


function ARKINV:IsTooltipReliable( bagnum )

	local r = true
	
	if ARKINV_G.LOCATION[self:BagLocation( bagnum )].player == ARKINV_G.ME then
	
		if ( ( self:BagLocation( bagnum ) == ARKINV_G.LOCATION_BANK ) and ARKINV_G.MODE.BANK == false ) then
			r = false
		end
	
	else
		r = false
	end

	return r
	
end


function ARKINV:CacheCleanup()

	self:Debug( "CacheCleanup() start" )

	for player, player_data in pairs( self.db.account.cache.who ) do

		for loc_id, loc_data in pairs( player_data.loc ) do
			
			--self:Debug( "checking cache: who=" .. player .. ", location=" .. loc_id )
			
			if loc_id == ARKINV_G.LOCATION_BANK and not self.db.profile.option.global.remember.bank then
				-- erase bank if not needed
				--self:Debug( "erasing cached bank data for " .. player )
				self.db.account.cache.who[player].loc[loc_id] = nil
			end
	
		end

		if player ~= ARKINV_G.ME and not self.db.profile.option.global.remember.alt then
			--self:Debug( "erasing cached data for " .. player )
			self.db.account.cache.who[player] = nil
		end

	end

	self:Debug( "CacheCleanup() end" )
	
end


function ARKINV:UiLocationID( widget_name )

	loc_id = strmatch( widget_name, ARKINV_G.GUI_NAME .. "(%d+)" )
	
	if not loc_id then
		return nil
	end
	
	return tonumber( loc_id )
	
end


function ARKINV:SkillGet()

	local good = false
	
	for j = 1, GetNumSkillLines() do
	
		local name, header = GetSkillLineInfo( j )

		if header ~= nil then
		
			if name == ARKINV_L["SKILL_1"] or name == ARKINV_L["SKILL_2"] then
				good = true
			else
				good = false
			end
			
		else
		
			if good then
				ARKINV_G.player_skills[ARKINV_L:GetReverseTranslation( name )] = j
			end
			
		end
		
	end
	
end


function ARKINV:HookBlizzardAPI()

	if self.db.profile.option.global.framehide.blizzard then
	
		self:Hook( "OpenBackpack", "HookBackpackOpen", true )
		self:Hook( "ToggleBackpack", "HookBackpackToggle", true )

		self:Hook( "OpenAllBags", "HookBackpackOpen", true )

		self:Hook( "ToggleKeyRing", "HookKeyringToggle", true )

		--self:Hook( "OpenBag", "HookBagOpen", true )
		--self:Hook( "ToggleBag", "HookBagToggle", true )

		self:Hook( "OpenBag", "HookDoNothing", true )
		self:Hook( "ToggleBag", "HookDoNothing", true )

		
		BankFrame:UnregisterEvent( "BANKFRAME_OPENED" )
		BankFrame:UnregisterEvent( "BANKFRAME_CLOSED" )
		
		
		
		--self:HookReport()
		
	else

		BankFrame:RegisterEvent( "BANKFRAME_OPENED" )
		BankFrame:RegisterEvent( "BANKFRAME_CLOSED" )
	
		self:UnhookAll()
		--self:HookReport()
	
	end
	
end

function ARKINV:HookBackpackOpen()
	self:Debug( { RED_FONT_COLOR_CODE, "HookBackpackOpen()" } )
	self:ContainerOpen( ARKINV_G.LOCATION_BAG )
end

function ARKINV:HookBackpackToggle()
	self:Debug( { RED_FONT_COLOR_CODE, "HookBackpackToggle()" } )
	self:ContainerToggle( ARKINV_G.LOCATION_BAG )
end

function ARKINV:HookBagOpen( bagnum )
	self:Debug( { RED_FONT_COLOR_CODE, "HookBagOpen( ", bagnum, " )" } )
	if bagnum then
		self:ContainerOpen( self:BagLocation( bagnum ), ARKINV_G.ME )
	end
end

function ARKINV:HookKeyringToggle()
	self:Debug( { RED_FONT_COLOR_CODE, "HookKeyringToggle()" } )
	self:ContainerToggle( ARKINV_G.LOCATION_KEY )
end

function ARKINV:HookBagToggle( bagnum )
	self:Debug( { RED_FONT_COLOR_CODE, "HookBagToggle( ", bagnum, " )" } )
	if bagnum then
		local loc_id = self:BagLocation( bagnum )
		self:ContainerToggle( loc_id )
	end
end

function ARKINV:HookDoNothing()
	self:Debug( { RED_FONT_COLOR_CODE, "HookDoNothing()" } )
	-- do nothing
end


function ARKINV:BagChangerUpdateBagSlotStatus() 

	-- update blizzards frame as well because the static dialog box uses the data in it
	UpdateBagSlotStatus()

	-- now mimc that frame in ours
	local purchaseFrame = ARKINV_BankFramePurchaseInfo
	if( purchaseFrame == nil ) then
		return
	end
	
	local numSlots, full = GetNumBankSlots()
	local button
	for i = 1, NUM_BANKBAGSLOTS do
		button = getglobal( "ARKINV___Bag" .. i )
		if button then
			if i <= numSlots then
				SetItemButtonTextureVertexColor( button, 1.0, 1.0, 1.0 )
				button.tooltipText = BANK_BAG
			else
				SetItemButtonTextureVertexColor( button, 1.0, 0.1, 0.1 )
				button.tooltipText = BANK_BAG_PURCHASE
			end
		end
	end

	-- pass in # of current slots, returns cost of next slot
	local cost = GetBankSlotCost( numSlots )
	
	ARKINV_BlizzardBankBagChanger.nextSlotCost = cost
	if( GetMoney() >= cost ) then
		SetMoneyFrameColor( "ARKINV_BankFrameDetailMoneyFrame", 1.0, 1.0, 1.0 )
		ARKINV_BankFramePurchaseButton:Enable()
	else
		SetMoneyFrameColor( "ARKINV_BankFrameDetailMoneyFrame", 1.0, 0.1, 0.1 )
		ARKINV_BankFramePurchaseButton:Disable()
	end
	MoneyFrame_Update( "ARKINV_BankFrameDetailMoneyFrame", cost )

	if full then
		purchaseFrame:Hide()
	else
		purchaseFrame:Show()
	end
	
end


function ARKINV:ContainerItemNameGet( parent, bagnum, slotnum )

	local pname
	
	if type( parent ) == "string" then
		pname = parent
	else
		pname = parent:GetName()
	end
	
	return pname .. bagnum .. "Item" .. slotnum

end


function ARKINV:OptionLocalGet( loc_id, opt )

	if not loc_id or not opt then
		return nil
	end

	if self.db.profile.option.global.useglobal then
		loc_id = ARKINV_G.LOCATION_BAG
	end
	
	if opt[5] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]][opt[5]]
	end
	
	if opt[4] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]]
	end
	
	if opt[3] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]]
	end
	
	if opt[2] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]]
	end
	
	if opt[1] then
		return self.db.profile.option["local"][loc_id][opt[1]]
	end

	return nil
	
end

function ARKINV:OptionLocalSet( loc_id, opt, v )

	if not loc_id or not opt then
		return
	end

	if self.db.profile.option.global.useglobal then
		loc_id = ARKINV_G.LOCATION_BAG
	end
	
	if opt[5] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]][opt[5]] = v
		return
	end
	
	if opt[4] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]] = v
		return
	end
	
	if opt[3] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]] = v
		return
	end
	
	if opt[2] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]] = v
		return
	end
	
	if opt[1] then
		self.db.profile.option["local"][loc_id][opt[1]] = v
		return
	end

	return nil
	
end


function ARKINV:ToggleBagChanger()
	self.db.profile.option.global.framehide.changer = not self.db.profile.option.global.framehide.changer
	self:ContainerGenerateRefreshAll()
end

function ARKINV:ToggleEditMode()
	ARKINV_G.MODE.EDIT = not ARKINV_G.MODE.EDIT
	self:ContainerGenerateRedrawAll()
end

function ARKINV:AnchorSet( loc_id, anchor )

	local obj = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	obj:ClearAllPoints()
	
	self:OptionLocalSet( loc_id, { "window", "anchor" }, anchor )
	
	if anchor == 1 then
		obj:SetPoint( "BOTTOMRIGHT" )
	end

	if anchor == 2 then
		obj:SetPoint( "BOTTOMLEFT" )
	end

	if anchor == 3 then
		obj:SetPoint( "TOPLEFT" )
	end

	if anchor == 4 then
		obj:SetPoint( "TOPRIGHT" )
	end

end


function ARKINV:Tooltip( this, txt )
	ARKINV_Tooltip:SetOwner( this, "ANCHOR_LEFT" )
	ARKINV_Tooltip:ClearLines()
	ARKINV_Tooltip:AddLine( txt )
	ARKINV_Tooltip:Show()
end


function ARKINV:ConvertOldOptions()

	-- don't store data in char db any more
	self:ResetDB( "char" )
	
	-- moved the background colour option
	if self.db.profile.option["window"] and self.db.profile.option.window["background"] then
		self.db.profile.option.window.colour.background = self.db.profile.option.window.background
		self.db.profile.option.window.background = nil
	end
	
	-- moved the close on combat option
	if self.db.profile.option["window"] and self.db.profile.option.window["combat"] then
		self.db.profile.option.window["auto"]["close"]["combat"] = self.db.profile.option.window.combat
		self.db.profile.option.window.combat = nil
	end

	-- moved the slot sort options
	if self.db.profile.option["slot"] and self.db.profile.option.slot["sort"] then
		self.db.profile.option["sort"]["type"] = self.db.profile.option.slot.sort
		self.db.profile.option.slot.sort = nil
	end
	
	-- remove none as an option to sort, use bag/slot instead
	if self.db.profile.option["sort"] and self.db.profile.option.sort["type"] then
		if self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_NONE then
			self.db.profile.option.sort.type = ARKINV_G.SLOT_SORT_BAGSLOT
		end
	end

	
	if self.db.profile.option["category"] and self.db.profile.option.category["item"] then
		-- new id format
		local new_cat = { }
		local new_key = nil
		for k, v in pairs( self.db.profile.option.category.item ) do
	
			new_key = k
	
			if strmatch( k, "^%-?%d+$" ) then -- original format, just the number
			
				-- adding suffix and soulbound
				new_key = k .. ".0.0.0"
			
			elseif strmatch( k, "^%-?%d+.%-?%d+.%-?%d+$" ) then -- second format id.suffix.soulbound
		
				-- moving soulbound and adding enchant
				local v1, v2, v3 = strmatch( k, "^(%-?%d+).(%-?%d+).(%-?%d+)" )
				new_key = v1 .. "." .. v3 .. "." .. v2 .. ".0"
			
			end
	
			-- id . soulbound . suffix . enchant
			new_cat[new_key] = v
		end
		self.db.profile.option["category"]["item"] = new_cat
	end


	-- individual window widths
	if self.db.profile.option["window"] and self.db.profile.option.window["col"] and type( self.db.profile.option.window.col ) == "number" then
		self.db.profile.option.window.col = {
			[ARKINV_G.LOCATION_BAG] = self.db.profile.option.window.col,
		}
	end

	-- move the default category to it's new id (so it can be hidden)
	if self.db.profile.option["category"] and self.db.profile.option.category["location"] and self.db.profile.option.category.location[0] then
		self.db.profile.option.category.location[ARKINV_G.CATEGORY_ID_DEFAULT] = self.db.profile.option.category.location[0]
		self.db.profile.option.category.location[0] = nil
	end
	
	-- 1.30 changes
	
	if self.db.profile.option["window"] then

		if self.db.profile.option.window["scale"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["scale"] = self.db.profile.option.window.scale
			self.db.profile.option.window.scale = nil
		end
		
		if self.db.profile.option.window["col"] then

			if self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG]
				self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG] = nil
			end

			if self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BANK]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK]
				self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK] = nil
			end

			if self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_KEY]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY]
				self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY] = nil
			end

			self.db.profile.option.window.col = nil
			
		end

		if self.db.profile.option.window["border"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["border"] = self.db.profile.option.window.border
			self.db.profile.option.window.border = nil
		end

		if self.db.profile.option.window["colour"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["colour"] = self.db.profile.option.window.colour
			self.db.profile.option.window.colour = nil
		end

		if self.db.profile.option.window["ignorehidden"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["slot"]["ignorehidden"] = self.db.profile.option.window.ignorehidden
			self.db.profile.option.window.ignorehidden = nil
		end

		if self.db.profile.option.window["auto"] then
			self.db.profile.option["global"]["auto"] = self.db.profile.option.window.auto
			self.db.profile.option.window.auto = nil
		end
	
		if self.db.profile.option.window["framehide"] then
			self.db.profile.option["global"]["framehide"] = self.db.profile.option.window.framehide
			self.db.profile.option.window.framehide = nil
		end

		self.db.profile.option.window["width"] = nil
		self.db.profile.option.window["hideblizzard"] = nil

	end
		
	self.db.profile.option["window"] = nil
		
	if self.db.profile.option["bar"] then
		self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["bar"] = self.db.profile.option.bar
		self.db.profile.option.bar = nil
	end

	if self.db.profile.option["slot"] then
		self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["slot"] = self.db.profile.option.slot
		self.db.profile.option.slot = nil
	end

	if self.db.profile.option["sort"] then
		self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["sort"] = self.db.profile.option.sort
		self.db.profile.option.sort = nil
	end

	if self.db.profile.option["category"] then
			
		if self.db.profile.option.category["custom"] then
			self.db.profile.option["global"]["category"]["custom"] = self.db.profile.option.category.custom
			self.db.profile.option.category.custom = nil
		end
		
		if self.db.profile.option.category["next"] then
			self.db.profile.option["global"]["category"]["next"] = self.db.profile.option.category.next
			self.db.profile.option.category.next = nil
		end
				
		if self.db.profile.option.category["item"] then
		
			for k, v in pairs( self.db.profile.option.category.item ) do
				if v == 0 then
					self.db.profile.option.category.item[k] = nil
				end
			end
		
			self.db.profile.option["global"]["category"]["item"] = self.db.profile.option.category.item
			self.db.profile.option.category.item = nil
		end

		if self.db.profile.option.category["location"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["category"] = self.db.profile.option.category.location
			self.db.profile.option.category.location = nil
		end
		
		self.db.profile.option.category = nil
		
	end
		
	if self.db.profile.option["offline"] then
		self.db.profile.option.global.remember = self.db.profile.option.offline
		self.db.profile.option.offline = nil
	end
	
	self.db.profile.option["sync"] = nil

	--self.db.profile.options.version = ARKINV_G.PROGRAM_VERSION
	
end

